/***************************************************************************
                          menubar.cpp  -  description
                             -------------------
    begin                : Sun Jan 9 2000
    copyright            : (C) 2000 by Joris Struyve
    email                : j.struyve@village.uunet.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* CVS information :
 *
 * $Id$
 *
 */

#include "qtabman.h"

MenuBar::MenuBar( QWidget *parent,char *name )
        : QMenuBar( parent, name)
{
	
	file = new QPopupMenu(this);
		file->insertItem( "Refresh",parent,SLOT(DoFullRefresh()));
		file->insertItem( "&Change connection",parent,SLOT(Logon()),CTRL+Key_L);
		file->insertSeparator();
		file->insertItem( "&Quit", qApp, SLOT(quit()), CTRL+Key_Q );
	
	view = new QPopupMenu(this);
		this->dbgwindow   = view->insertItem( "&Debugwindow", parent, SLOT(ShowHideDebugDialog()) );
		this->dbggenerate = view->insertItem( "&Generate debug", parent, SLOT(SetUnsetDebug()) );
		view->setItemChecked(dbgwindow  ,FALSE);
		view->setItemChecked(dbggenerate,FALSE);
		view->insertSeparator();
		
		this->tabmanwindow = view->insertItem( "&Tabman messages", parent, SLOT(ShowHideTabmanDialog()) );
		this->tabmanscan   = view->insertItem( "&Read Tabman messages", parent, SLOT(SetUnsetTabmanMessages()) );
		view->setItemChecked(tabmanwindow  ,FALSE);
		view->setItemChecked(tabmanscan,TRUE);
		view->insertSeparator();
		
		this->tablewind = view->insertItem("Table properties...", parent, SLOT(ShowHideTableDialog()) );
		this->indexwind = view->insertItem("Index properties...", parent, SLOT(ShowHideIndexDialog()) );
		this->constraintwind = view->insertItem("Constraint properties...", parent, SLOT(ShowHideConstraintDialog()) );
		this->columnwind = view->insertItem("Column properties...", parent, SLOT(ShowHideColumnDialog()) );
		view->setItemChecked(tablewind  ,FALSE);
		view->setItemChecked(indexwind ,FALSE);
		view->setItemChecked(constraintwind ,FALSE);
		view->setItemChecked(columnwind,FALSE);

	
	tools = new QPopupMenu(this);
		tools->insertItem("Tabman batch operations...");
		tools->insertItem("SqlPlus..",parent,SLOT(StartSqlPlus()) );
		view->insertSeparator();
		tools->insertItem("&Options...");

	help = new QPopupMenu(this);
		help->insertItem( "&About", parent, SLOT(ShowAbout()), CTRL+Key_A );
	
	this->insertItem( "&File", file );
	this->insertItem( "&View", view );
	this->insertItem( "&Tools", tools );
	this->insertItem( "&Help", help);

}

MenuBar::~MenuBar()
{}