/***************************************************************************
                          schemalist.cpp  -  description
                             -------------------
    begin                : Thu Jan 6 2000
    copyright            : (C) 2000 by Joris Struyve
    email                : j.struyve@village.uunet.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* CVS information :
 *
 * $Id$
 *
 */

#include "qtabman.h"

SchemaList::SchemaList(QWidget *parent,char *label)
	:QListView(parent,label)
{
	this->addColumn(NULL);
	this->addColumn(NULL);
	this->addColumn(NULL);
	this->addColumn(NULL);
	this->setAllColumnsShowFocus (TRUE) ;
	
	/* Connect the listview slots and signals */
	QObject::connect( this, SIGNAL(doubleClicked(QListViewItem *)),
				 this,SLOT(SchemaListDoubleClick()) );
	
	QObject::connect( this, SIGNAL(currentChanged(QListViewItem *)),
				 this,SLOT(SchemaListClick()) );

	QObject::connect( this, SIGNAL(rightButtonClicked ( QListViewItem *, const QPoint &, int )),
				 this,SLOT(SchemaListRightClick(QListViewItem *, const QPoint &, int)) );
}

SchemaList::~SchemaList()
{
}

int SchemaList::RefreshSchemaList()
{
	int tel,aantal;
	char **data1=NULL;
	char **data2=NULL;
	char **data3=NULL;
	char **data4=NULL;
	char *err=NULL;

	/*Debug("---------------Begin SchemaList Refresh------------");
	Debug("	name ='%s'",(const char*)this->name);
	Debug("	type ='%s'",(const char*)this->type);
	Debug("	parent name ='%s'",(const char*)this->parent_name);
	Debug("	parent type ='%s'",(const char*)this->parent_type);
	Debug("	level  ='%d'",this->level);
	Debug("	folder ='%d'",this->folder);
	Debug("	param1 ='%s'",(const char*)this->param1);
	Debug("	param2 ='%s'",(const char*)this->param2);
	Debug("---------------End SchemaList Refresh---------------");*/
	
	/* clear the current contents */
	this->clear();
	this->setColumnText(0,NULL);
	this->setColumnText(1,NULL);
	this->setColumnText(2,NULL);
	this->setColumnText(3,NULL);
	
	aantal = 0;
	/* hourglass cursor */
    QApplication::setOverrideCursor( waitCursor );
        
	switch (this->level)
	{
	case 1: /*root select (first level select)*/
		if(GetAllUserObjects(&data1,&data2,&data3,&data4,&aantal,&err))
		{
			this->setColumnText(0,"Name");
			this->setColumnText(1,"Type");
			this->setColumnText(2,"Status");
			this->setColumnText(3,"Created");
			for(tel=0;tel<aantal;tel++)
			{
				SchemaListItem *newitem = new SchemaListItem(this,NULL,NULL
								,data2[tel]
								,data1[tel]
								,NULL,NULL,FALSE,FALSE
								,data1[tel]
								,data2[tel]
								,data3[tel]
								,data4[tel]);
			}
		}
		else
		{
			QApplication::restoreOverrideCursor();
			QMessageBox::message("Error",err);
		}
		break;
	case 2: /*second level select*/
 			if(!strcmp(this->type,"TABLE"))
 			{
 				if(GetUserTables(&data1,&data2,&aantal,&err))
 				{
  					this->setColumnText(0,"Name");
					this->setColumnText(1,"Tablespace");				
					this->setColumnText(2,"");				
					this->setColumnText(3,"");				
					for(tel=0;tel<aantal;tel++)
					{
						SchemaListItem *newitem = new SchemaListItem(this,NULL,NULL
										,this->type
										,QString((const char*)data1[tel])
										,NULL,NULL,TRUE,TRUE
										,QString((const char*)data1[tel])
										,QString((const char*)data2[tel]) );
					}

 				}
 				else
 				{
 					QApplication::restoreOverrideCursor();
 					QMessageBox::message("Error",err);
 				}
 			}
 			if(!strcmp(this->type,"INDEX"))
 			{
 				if(GetUserIndexes(&data1,&data2,&data3,&data4,&aantal,&err))
 				{
  					this->setColumnText(0,QString("Name"));
					this->setColumnText(1,QString("Type"));
					this->setColumnText(2,QString("Table name"));
					this->setColumnText(3,QString("Tablespace"));	
					for(tel=0;tel<aantal;tel++)
					{
						SchemaListItem *newitem = new SchemaListItem(this,NULL,NULL
										,this->type
										,QString(data1[tel])
										,NULL,NULL,TRUE,TRUE
										,QString(data1[tel])
										,QString(data2[tel])
										,QString(data3[tel])
										,QString(data4[tel]) );
					}

 				}
 				else
 				{
 					QApplication::restoreOverrideCursor();
 					QMessageBox::message("Error",err);
 				}
 			}
 			if(!strcmp(this->type,"PROCEDURE")||!strcmp(this->type,"VIEW")||!strcmp(this->type,"PACKAGE"))
 			{
 				if(GetUserObjects(&data1,&data2,&data3,&data4,(const char*)this->type,&aantal,&err))
 				{
 					this->setColumnText(0,QString("Name"));
					this->setColumnText(1,QString("Status"));
					this->setColumnText(2,QString("Created"));
					this->setColumnText(3,QString("Timestamp"));				
					for(tel=0;tel<aantal;tel++)
					{
						SchemaListItem *newitem = new SchemaListItem(this,NULL,NULL
										,this->type
										,QString(data1[tel])
										,NULL,NULL,TRUE,TRUE
										,QString(data1[tel])
										,QString(data2[tel])
										,QString(data3[tel])
										,QString(data4[tel]) );
					}
 				}
 				else
 				{
 					QApplication::restoreOverrideCursor();
 					QMessageBox::message("Error",err);
 				}
 			}
		
		break;
	case 3: /*third level select*/
		if( !strcmp(this->type,"TABLE") )
		{
			/* sum all the objects found */
			int totaantal;
			
			this->setColumnText(0,QString("Object name"));
			this->setColumnText(1,QString("Object type"));
			this->setColumnText(2,QString(""));
			this->setColumnText(3,QString(""));
			
			if(GetTableColumns(&data1,(const char*)this->name,&aantal,&err))
			{
				for(tel=0;tel<aantal;tel++)
				{
					SchemaListItem *newitem = new SchemaListItem(this,this->type,this->name
								,QString("COLUMN")
								,QString(data1[tel])
								,NULL,NULL,FALSE,FALSE
								,QString(data1[tel])
								,QString("COLUMN") );
				}
			}
			else
			{
				QApplication::restoreOverrideCursor();
				QMessageBox::message("Error",err);
			}
			totaantal = aantal;
			if(GetTableIndexDetails(&data1,&data2,&data3,&data4,(const char*)this->name,&aantal,&err))
			{
				for(tel=0;tel<aantal;tel++)
				{
					SchemaListItem *newitem = new SchemaListItem(this,this->type,this->name
								,"INDEX"
								,data1[tel]
								,NULL,NULL,FALSE,FALSE
								,data1[tel]
								,"INDEX");
				}
			}
			else
			{
				QApplication::restoreOverrideCursor();
				QMessageBox::message("Error",err);
			}
			totaantal = totaantal + aantal;
			if(GetTableTriggerDetails(&data1,&data2,&data3,&data4,(const char*)this->name,&aantal,&err))
			{
				for(tel=0;tel<aantal;tel++)
				{
					SchemaListItem *newitem = new SchemaListItem(this,this->type,this->name
								,"TRIGGER"
								,data1[tel]
								,NULL,NULL,FALSE,FALSE
								,data1[tel]
								,"TRIGGER");
				}
			}
			else
			{
				QApplication::restoreOverrideCursor();
				QMessageBox::message("Error",err);
			}
			totaantal = totaantal + aantal;
			if(GetTableConstraintDetails(&data1,&data2,&data3,&data4,(const char*)this->name,&aantal,&err))
			{
				for(tel=0;tel<aantal;tel++)
				{
					SchemaListItem *newitem = new SchemaListItem(this,this->type,this->name
								,"CONSTRAINT"
								,data1[tel]
								,NULL,NULL,FALSE,FALSE
								,data1[tel]
								,"CONSTRAINT");
				}
			}
			else
			{
				QApplication::restoreOverrideCursor();
				QMessageBox::message("Error",err);
			}
			totaantal = totaantal + aantal;
			aantal = totaantal;
			
		}
		if( !strcmp(this->type,"INDEX") )
		{
			if(GetIndexDetails(&data1,&data2,(const char*)this->name,&aantal,&err))
			{
				this->setColumnText(0,"Table name");
				this->setColumnText(1,"Column name");
				this->setColumnText(2,"");
				this->setColumnText(3,"");
				for(tel=0;tel<aantal;tel++)
				{
					SchemaListItem *newitem = new SchemaListItem(this,this->type,this->name
								,"COLUMN"
								,data2[tel]
								,NULL,NULL,FALSE,FALSE
								,data1[tel]
								,data2[tel]);
				}
			}
			else
			{
				QApplication::restoreOverrideCursor();
				QMessageBox::message("Error",err);
			}
		}
		if( !strcmp(this->type,"VIEW") )
		{
			if(GetTableColumnDetails(&data1,&data2,&data3,&data4,
					(const char*)this->name,&aantal,&err))
			{
				this->setColumnText(0,"Column name");
				this->setColumnText(1,"Datatype");
				this->setColumnText(2,"Length");
				this->setColumnText(3,"Comment");
				for(tel=0;tel<aantal;tel++)
				{
					SchemaListItem *newitem = new SchemaListItem(this,this->type,this->name
								,"VIEWCOLUMN"
								,data1[tel]
								,NULL,NULL,TRUE,TRUE
								,data1[tel]
								,data2[tel]
								,data3[tel]
								,data4[tel]);
				}
			}
			else
			{
				QApplication::restoreOverrideCursor();
				QMessageBox::message("Error",err);
			}
		}
		if( !strcmp(this->type,"PACKAGE") )
		{
			if(GetPackageBodyNames(&data1,&data2,&data3,(const char*)this->name,&aantal,&err))
			{
				this->setColumnText(0,"Body name");
				this->setColumnText(1,"");
				this->setColumnText(2,"");
				this->setColumnText(3,"");
				for(tel=0;tel<aantal;tel++)
				{
					SchemaListItem *newitem = new SchemaListItem(this,this->type,this->name
								,"PACKAGE BODY"
								,data3[tel]
								,NULL,NULL,FALSE,FALSE
								,data3[tel]);
				}
			}
			else
			{
				QApplication::restoreOverrideCursor();
				QMessageBox::message("Error",err);
			}
		}
		if( !strcmp(this->type,"PROCEDURE") )
		{
			if(GetProcedureArguments(&data1,&data2,&data3,&data4,(const char*)this->name,&aantal,&err))
			{
				this->setColumnText(0,"Argument name");
				this->setColumnText(1,"Datatype");
				this->setColumnText(2,"In/Out");
				this->setColumnText(3,"Position");
				for(tel=0;tel<aantal;tel++)
				{
					SchemaListItem *newitem = new SchemaListItem(this,this->type,this->name
									,this->type
									,data1[tel]
									,NULL,NULL,FALSE,FALSE
									,data1[tel]
									,data2[tel]
									,data3[tel]
									,data4[tel]);
				}
			}
			else
			{
				QApplication::restoreOverrideCursor();
				QMessageBox::message("Error",err);
			}
		}
	case 4: /* fourth level click*/
		if( !strcmp(this->parent_type,"TABLE") )
		{
			if( !strcmp(this->type,"COLUMN") )
			{
				if(GetTableColumnDetails(&data1,&data2,&data3,&data4,
						(const char*)this->parent_name,&aantal,&err))
				{
					this->setColumnText(0,"Column name");
					this->setColumnText(1,"Datatype");
					this->setColumnText(2,"Length");
					this->setColumnText(3,"Comment");
					for(tel=0;tel<aantal;tel++)
					{
						SchemaListItem *newitem = new SchemaListItem(this,this->parent_type,this->parent_name
									,"COLUMN"
									,data1[tel]
									,NULL,NULL,TRUE,TRUE
									,data1[tel]
									,data2[tel]
									,data3[tel]
									,data4[tel]);
					}
				}
				else
				{
					QApplication::restoreOverrideCursor();
					QMessageBox::message("Error",err);
				}
			}
			if( !strcmp(this->type,"CONSTRAINT") )
			{
				if(GetTableConstraintDetails(&data1,&data2,&data3,&data4,
						(const char*)this->parent_name,&aantal,&err))
				{
					this->setColumnText(0,"Name");
					this->setColumnText(1,"Type");
					this->setColumnText(2,"Status");
					this->setColumnText(3,"Delete rule");
					for(tel=0;tel<aantal;tel++)
					{
						SchemaListItem *newitem = new SchemaListItem(this,this->parent_type,this->parent_name
									,"CONSTRAINT"
									,data1[tel]
									,NULL,NULL,TRUE,TRUE
									,data1[tel]
									,data2[tel]
									,data3[tel]
									,data4[tel]);
					}
				}
				else
				{
					QApplication::restoreOverrideCursor();
					QMessageBox::message("Error",err);
				}
			}
			if( !strcmp(this->type,"INDEX") )
			{
				if(GetTableIndexDetails(&data1,&data2,&data3,&data4,
						(const char*)this->parent_name,&aantal,&err))
				{
					this->setColumnText(0,"Name");
					this->setColumnText(1,"Type");
					this->setColumnText(2,"Uniqueness");
					this->setColumnText(3,"Tablespace");
					for(tel=0;tel<aantal;tel++)
					{
						SchemaListItem *newitem = new SchemaListItem(this,this->parent_type,this->parent_name
									,"INDEX"
									,data1[tel]
									,NULL,NULL,TRUE,TRUE
									,data1[tel]
									,data2[tel]
									,data3[tel]
									,data4[tel]);
					}
				}
				else
				{
					QApplication::restoreOverrideCursor();
					QMessageBox::message("Error",err);
				}
			}
			if( !strcmp(this->type,"TRIGGER") )
			{
				if(GetTableTriggerDetails(&data1,&data2,&data3,&data4,
						(const char*)this->parent_name,&aantal,&err))
				{
					this->setColumnText(0,"Name");
					this->setColumnText(1,"Type");
					this->setColumnText(2,"Status");
					this->setColumnText(3,"Event");
					for(tel=0;tel<aantal;tel++)
					{
						SchemaListItem *newitem = new SchemaListItem(this,this->parent_type,this->parent_name
									,"TRIGGER"
									,data1[tel]
									,NULL,NULL,TRUE,TRUE
									,data1[tel]
									,data2[tel]
									,data3[tel]
									,data4[tel]);
					}
				}
				else
				{
					QApplication::restoreOverrideCursor();
					QMessageBox::message("Error",err);
				}
			}
		} /*end if TABLE*/
		if( !strcmp(this->type,"PACKAGE BODY") )
		{
			if(GetBodyArguments(&data1,&data2,&data3,&data4,
							(const char*)this->parent_name,
							(const char*)this->param1,
							(const char*)this->param2,
							&aantal,&err))
			{
				this->setColumnText(0,"Argument name");
				this->setColumnText(1,"Datatype");
				this->setColumnText(2,"In/Out");
				this->setColumnText(3,"Position");
				for(tel=0;tel<aantal;tel++)
				{
					SchemaListItem *newitem = new SchemaListItem(this,this->type,this->name
								,"ARGUMENT"
								,data1[tel]
								,NULL,NULL,FALSE,FALSE
								,data1[tel]
								,data2[tel]
								,data3[tel]
								,data4[tel]);
				}
			}
			else
			{
				QApplication::restoreOverrideCursor();
				QMessageBox::message("Error",err);
			}
		}
	   	break;
	}
        
    /* restore cursor */
	QApplication::restoreOverrideCursor();

	/* free allocated space */
	free(err);
	free(data1);
	free(data2);
	free(data3);
	free(data4);
	
	/* set the number of objects in the statusbar */
	emit ObjectCountChanged(aantal);
}

int SchemaList::SetNewProperties(QString new_name, QString new_type,
			     QString new_parent_name, QString new_parent_type,
			     int itemlevel,bool isfolder,QString new_param1,QString new_param2)
{
	/* Set the new properties for the schemalistview */
	if (new_name!=NULL&&new_type!=NULL)
	{
		this->name = new_name;
		this->type = new_type;
		this->parent_name = new_parent_name;
		this->parent_type = new_parent_type;
		this->folder = isfolder;
		this->level  = itemlevel;
		this->param1 = new_param1;
		this->param2 = new_param2;
		
		/* properties have changed , so do a refresh */
		this->RefreshSchemaList();		
		
		return 0;
	}
	else
		return 1;
		
}


void SchemaList::SchemaListClick()
{
	SchemaListItem *item;
	ApplicationWindow *wind;
	wind = (ApplicationWindow*)qApp->mainWidget();
	
	item = (SchemaListItem *)this->currentItem();
	if(item)
	{
		emit NewObjectSelected(item->name,item->type,item->parent_name,item->parent_type);
	}
}

void SchemaList::SchemaListDoubleClick()
{
	SchemaListItem *item;
	ApplicationWindow *wind;

	wind = (ApplicationWindow*)qApp->mainWidget();
	
	/* cast the QListItem to a SchemaListItem */
	item = (SchemaListItem *)this->currentItem();
	
	if(item)
	{
		Debug("---------------Begin SchemaListItem properties------------");
		Debug("	name ='%s'",(const char*)item->name);
		Debug("	type ='%s'",(const char*)item->type);
		Debug("	parent name ='%s'",(const char*)item->parent_name);
		Debug("	parent type ='%s'",(const char*)item->parent_type);
		Debug("---------------End SchemaListItem properties--------------");
		emit NewObjectSelected(item->name,item->type,item->parent_name,item->parent_type);
		wind->ShowObjectProperties();
	}	
}


void SchemaList::SchemaListRightClick(QListViewItem *clickeditem, const QPoint &pos, int x)
{
	QPopupMenu *rclick = new QPopupMenu();
	SchemaListItem *item;

	/* cast the QListItem to a SchemaListItem */
	item = (SchemaListItem*)clickeditem;

	this->setSelected (item,TRUE);
	/* only show popup if cursor is over an item */
	if(item)
	{
		rclick->insertItem( item->name);
		
		if(!strcmp(item->type,"TABLE")
		 ||!strcmp(item->type,"COLUMN")
		 ||!strcmp(item->type,"INDEX")
		 ||!strcmp(item->type,"CONSTRAINT") )
		{
			rclick->insertSeparator();
			rclick->insertItem( "Drop...", this, SLOT(SchemaListItemDrop()), CTRL+Key_N );
			rclick->insertItem( "Properties...", this, SLOT(SchemaListDoubleClick()), CTRL+Key_N );
		}
		rclick->exec(QCursor::pos());
	}
	/* else , display a general menu */
	else
	{
		rclick->insertItem( "Refresh list",this, SLOT(DoRefresh()), CTRL+Key_R );
		rclick->exec(QCursor::pos());
	}
		
}

void SchemaList::SchemaListItemDrop()
{

	char pipe[]="TABMANPIPE";
	char *param1,param2;
	char *err;
	int stat;
	bool errorflag=FALSE;
	void *dummy;
	SchemaListItem *item;
	ApplicationWindow *wind;
	int frk_status;
	char itemname[31];
	char itemparent[31];
	char itemtype[31];
	char schemaname[31];
	char username[31];
	char password[31];
	char database[31];
	pid_t frk_id;

	/* get the currently selected item */
	item = (SchemaListItem*)this->currentItem();
	
	/* ask confirmation */
	if (QMessageBox::warning(this,"Qtabman","Drop "+item->type.lower()+" "+item->name+" ?","&Yes","&No",0,0, 1 ))
		return;

	/* get a pointer to the main application window */
	wind = (ApplicationWindow*)qApp->mainWidget();

	/* show the tabman dialog */
	wind->ShowTabmanDialog();	
	
	strcpy(username,(const char*)wind->username);
	strcpy(password,(const char*)wind->password);
	strcpy(database,(const char*)wind->database);
	strcpy(schemaname,(const char*)wind->schemaname);
	if(item)
	{
        strcpy(itemname,(const char*)item->name);
		strcpy(itemparent,(const char*)item->parent_name);
		strcpy(itemtype,(const char*)item->type);

        if( fork() == 0)
        {
        	if(ConnectToOracle(username,password,database,&err))
            {
				if(!strcmp(itemtype,"COLUMN"))
					if(!DropColumn(itemname,itemparent,schemaname,"TABMANPIPE",&err))
	            		errorflag=TRUE;
	            		
				if(!strcmp(itemtype,"TABLE"))
					if(!DropTable(itemname,schemaname,"TABMANPIPE",&err))
	                	errorflag=TRUE;
	                	
				if(!strcmp(itemtype,"INDEX"))
					if(!DropIndex(itemname,schemaname,"TABMANPIPE",&err))
	                	errorflag=TRUE;
	                	
				if(!strcmp(itemtype,"TRIGGER"))
					if(!DropTrigger(itemname,schemaname,"TABMANPIPE",&err))
	                	errorflag=TRUE;
	                	
				if(!strcmp(itemtype,"CONSTRAINT"))
					if(!DropConstraint(itemname,schemaname,"TABMANPIPE",&err))
	                	errorflag=TRUE;
	                	
				/* if an error okkert */
				if(errorflag)
					if(!SendToPipe("TABMANPIPE","QTABMAN",err,&err))
	                	qDebug("ERROR in SendToPipe : %s",err);

 			} /* end if connecttooracle */
            DisconnectFromOracle();
            exit(0);
		} /* end if fork */
	} /* end if item */
	else
	{
		Debug("NULL item, nothing done.");
		return;
	}
}
void SchemaList::DoRefresh()
{
	this->RefreshSchemaList();
}

void SchemaList::focusInEvent ( QFocusEvent * e)
{
	emit Click();
	QListView::focusInEvent(e);
}