/***************************************************************************
                          toolbar.cpp  -  description
                             -------------------
    begin                : Sun Jan 9 2000
    copyright            : (C) 2000 by Joris Struyve
    email                : j.struyve@village.uunet.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* CVS information :
 *
 * $Id$
 *
 */

#include "qtabman.h"
#include "properties.xpm"
#include "reconnect.xpm"
#include "refresh.xpm"
#include "tabman.xpm"
#include "tableprop.xpm"
#include "indexprop.xpm"
#include "columnprop.xpm"
#include "constrprop.xpm"

ToolBar::ToolBar( ApplicationWindow *parent,char *name )
        : QToolBar( parent, name)
{
	QPixmap refreshicon( (const char **)refresh_xpm );
	QPixmap exiticon( (const char **)exit_xpm );
	QPixmap propicon( (const char **)properties_xpm );
	QPixmap connecticon( (const char **)reconnect_xpm );
	QPixmap tableprop( (const char **)tableprop_xpm );
	QPixmap indexprop( (const char **)indexprop_xpm );
	QPixmap constrprop( (const char **)constrprop_xpm );
	QPixmap columnprop( (const char **)columnprop_xpm );
	QPixmap tabman( (const char **)tabman_xpm );
	
	quit       = new QToolButton(exiticon   , "Quit"    ,"Quit application", qApp, SLOT(quit()), this, "quit" );
	connect    = new QToolButton(connecticon, "Connect" ,"Change connection", parent, SLOT(Logon()), this, "refresh" );
	refresh    = new QToolButton(refreshicon, "Refresh" ,"Refresh the view", parent, SLOT(DoFullRefresh()), this, "refresh" );
	this->addSeparator();
	
	drop       = new QToolButton(this,"drop");
	prop       = new QToolButton(propicon, "Properties" ,"Show object properties", parent, SLOT(ShowObjectProperties()), this, "refresh" );
	this->addSeparator();
	
	tabmanwind = new QToolButton(tabman, "Tabman Window" ,"Show tabman message window", parent, SLOT(ShowHideTabmanDialog()), this, "refresh" );
	this->addSeparator();
	
	tablewind  = new QToolButton(tableprop, "Table properies" ,"Show table properties window", parent, SLOT(ShowHideTableDialog()), this, "tablewind" );
	indexwind  = new QToolButton(indexprop, "Index properties" ,"Show index properties window", parent, SLOT(ShowHideIndexDialog ()), this, "indexwind" );
	constrwind = new QToolButton(constrprop, "Constraint properties" ,"Show constraint properties window", parent, SLOT(ShowHideConstraintDialog ()), this, "constrwind" );
	colwind    = new QToolButton(columnprop, "Column properties" ,"Show column properties window", parent, SLOT(ShowHideColumnDialog ()), this, "colwind" );
	this->addSeparator();
	
	/* set certain buttons to be togglebuttons */
	tabmanwind->setToggleButton(TRUE);
	tablewind->setToggleButton(TRUE);
	indexwind->setToggleButton(TRUE);
	constrwind->setToggleButton(TRUE);
	colwind->setToggleButton(TRUE);
}

ToolBar::~ToolBar()
{}
