
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned int magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* Object support */
struct sqltvn
{
  unsigned char *tvnvsn; 
  unsigned short tvnvsnl; 
  unsigned char *tvnnm;
  unsigned short tvnnml; 
  unsigned char *tvnsnm;
  unsigned short tvnsnml;
};
typedef struct sqltvn sqltvn;

struct sqladts
{
  unsigned int adtvsn; 
  unsigned short adtmode; 
  unsigned short adtnum;  
  sqltvn adttvn[1];       
};
typedef struct sqladts sqladts;

static struct sqladts sqladt = {
  1,1,0,
};

/* Binding to PL/SQL Records */
struct sqltdss
{
  unsigned int tdsvsn; 
  unsigned short tdsnum; 
  unsigned char *tdsval[1]; 
};
typedef struct sqltdss sqltdss;
static struct sqltdss sqltds =
{
  1,
  0,
};

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[13];
};
static const struct sqlcxp sqlfpn =
{
    12,
    "oragetlib.pc"
};


static const unsigned int sqlctx = 1;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   occurs;
      const short *cud;
   unsigned char  *sqlest;
      const char  *stmt;
   sqladts *sqladtp;
   sqltdss *sqltdsp;
            void  **sqphsv;
   unsigned int   *sqphsl;
            int   *sqphss;
            void  **sqpind;
            int   *sqpins;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned short  *sqpadto;
   unsigned short  *sqptdso;
            void  *sqhstv[17];
   unsigned int   sqhstl[17];
            int   sqhsts[17];
            void  *sqindv[17];
            int   sqinds[17];
   unsigned int   sqharm[17];
   unsigned int   *sqharc[17];
   unsigned short  sqadto[17];
   unsigned short  sqtdso[17];
} sqlstm = {10,17};

// SQLLIB Prototypes
extern "C" {
  void sqlcxt (void **, unsigned int *,
               struct sqlexd *, const struct sqlcxp *);
  void sqlcx2t(void **, unsigned int ,
               struct sqlexd *, const struct sqlcxp *);
  void sqlbuft(void **, char *);
  void sqlgs2t(void **, char *);
  void sqlorat(void **, unsigned int *, void *);
}

// Forms Interface
static const int IAPSUCC = 0;
static const int IAPFAIL = 1403;
static const int IAPFTL  = 535;
extern "C" { void sqliem(char *, int *); }

 static const char *sq0005 = 
"select object_name ,status ,to_char(created,'dd-mm-yyyy hh24:mi') , timestam\
p   from user_objects where object_type=:b0           ";

 static const char *sq0007 = 
"select table_name ,tablespace_name  from user_tables            ";

 static const char *sq0009 = 
"select table_name ,column_name  from user_ind_columns where index_name=:b0  \
         ";

 static const char *sq0011 = 
"select index_name ,index_type ,table_name ,tablespace_name  from user_indexe\
s            ";

 static const char *sq0013 = 
"select object_name  from user_objects where object_type=:b0 order by 1 desc \
            ";

 static const char *sq0015 = 
"select object_name ,object_type ,status ,to_char(created,'dd-mm-yyyy hh24:mi\
')  from user_objects            ";

 static const char *sq0017 = 
"select column_name  from user_tab_columns where table_name=:b0           ";

 static const char *sq0019 = 
"select index_name ,index_type ,uniqueness ,tablespace_name  from user_indexe\
s where table_name=:b0           ";

 static const char *sq0021 = 
"select constraint_name ,constraint_type ,status ,delete_rule  from user_cons\
traints where table_name=:b0           ";

 static const char *sq0023 = 
"select trigger_name ,trigger_type ,status ,triggering_event  from user_trigg\
ers where table_name=:b0           ";

 static const char *sq0025 = 
"select object_name ,overload ,(((object_name||'(')||overload)||')')  from us\
er_arguments where package_name=:b0 group by object_name,overload order by 1 d\
esc             ";

 static const char *sq0027 = 
"select utc.column_name ,utc.data_type ,decode(data_type,'NUMBER',((to_char(d\
ata_precision)||',')||to_char(data_scale))) ,ucc.comments  from user_tab_colum\
ns utc ,user_col_comments ucc where ((utc.table_name=:b0 and ucc.column_name=u\
tc.column_name) and ucc.table_name=utc.table_name)           ";

 static const char *sq0029 = 
"select argument_name ,data_type ,in_out ,to_char(position)  from user_argume\
nts where (((package_name=:b0 and object_name=:b1) and (overload=:b2 or overlo\
ad is null )) and data_level=0) order by position            ";

 static const char *sq0031 = 
"select argument_name ,data_type ,in_out ,to_char(position)  from user_argume\
nts where (object_name=:b0 and data_level=0) order by position            ";

typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* cud (compilation unit data) array */
static const short sqlcud0[] =
{10,4130,0,0,0,
5,0,0,1,0,0,27,48,0,0,4,4,0,1,0,1,9,0,0,1,10,0,0,1,10,0,0,1,10,0,0,
36,0,0,2,0,0,27,68,0,0,4,4,0,1,0,1,9,0,0,1,10,0,0,1,10,0,0,1,10,0,0,
67,0,0,3,0,0,32,79,0,0,0,0,0,1,0,
82,0,0,4,65,0,4,111,0,0,2,1,0,1,0,2,3,0,0,1,9,0,0,
105,0,0,5,130,0,9,126,0,0,1,1,0,1,0,1,9,0,0,
124,0,0,5,0,0,13,133,0,0,4,0,0,1,0,2,9,0,0,2,9,0,0,2,9,0,0,2,9,0,0,
155,0,0,5,0,0,15,150,0,0,0,0,0,1,0,
170,0,0,6,43,0,4,170,0,0,1,0,0,1,0,2,3,0,0,
189,0,0,7,64,0,9,184,0,0,0,0,0,1,0,
204,0,0,7,0,0,13,191,0,0,2,0,0,1,0,2,9,0,0,2,9,0,0,
227,0,0,7,0,0,15,202,0,0,0,0,0,1,0,
242,0,0,8,68,0,4,225,0,0,2,1,0,1,0,2,3,0,0,1,9,0,0,
265,0,0,9,85,0,9,240,0,0,1,1,0,1,0,1,9,0,0,
284,0,0,9,0,0,13,247,0,0,2,0,0,1,0,2,9,0,0,2,9,0,0,
307,0,0,9,0,0,15,259,0,0,0,0,0,1,0,
322,0,0,10,44,0,4,279,0,0,1,0,0,1,0,2,3,0,0,
341,0,0,11,89,0,9,293,0,0,0,0,0,1,0,
356,0,0,11,0,0,13,300,0,0,4,0,0,1,0,2,9,0,0,2,9,0,0,2,9,0,0,2,9,0,0,
387,0,0,11,0,0,15,317,0,0,0,0,0,1,0,
402,0,0,12,65,0,4,340,0,0,2,1,0,1,0,2,3,0,0,1,9,0,0,
425,0,0,13,88,0,9,356,0,0,1,1,0,1,0,1,9,0,0,
444,0,0,13,0,0,13,363,0,0,1,0,0,1,0,2,9,0,0,
463,0,0,13,0,0,15,371,0,0,0,0,0,1,0,
478,0,0,14,44,0,4,390,0,0,1,0,0,1,0,2,3,0,0,
497,0,0,15,109,0,9,405,0,0,0,0,0,1,0,
512,0,0,15,0,0,13,412,0,0,4,0,0,1,0,2,9,0,0,2,9,0,0,2,9,0,0,2,9,0,0,
543,0,0,15,0,0,15,429,0,0,0,0,0,1,0,
558,0,0,16,68,0,4,450,0,0,2,1,0,1,0,2,3,0,0,1,9,0,0,
581,0,0,17,73,0,9,461,0,0,1,1,0,1,0,1,9,0,0,
600,0,0,17,0,0,13,468,0,0,1,0,0,1,0,2,9,0,0,
619,0,0,17,0,0,15,475,0,0,0,0,0,1,0,
634,0,0,18,64,0,4,497,0,0,2,1,0,1,0,2,3,0,0,1,9,0,0,
657,0,0,19,109,0,9,515,0,0,1,1,0,1,0,1,9,0,0,
676,0,0,19,0,0,13,522,0,0,4,0,0,1,0,2,9,0,0,2,9,0,0,2,9,0,0,2,9,0,0,
707,0,0,19,0,0,15,542,0,0,0,0,0,1,0,
722,0,0,20,68,0,4,563,0,0,2,1,0,1,0,2,3,0,0,1,9,0,0,
745,0,0,21,115,0,9,580,0,0,1,1,0,1,0,1,9,0,0,
764,0,0,21,0,0,13,587,0,0,4,0,0,1,0,2,9,0,0,2,9,0,0,2,9,0,0,2,9,0,0,
795,0,0,21,0,0,15,605,0,0,0,0,0,1,0,
810,0,0,22,65,0,4,627,0,0,2,1,0,1,0,2,3,0,0,1,9,0,0,
833,0,0,23,111,0,9,646,0,0,1,1,0,1,0,1,9,0,0,
852,0,0,23,0,0,13,653,0,0,4,0,0,1,0,2,9,0,0,2,9,0,0,2,9,0,0,2,9,0,0,
883,0,0,23,0,0,15,673,0,0,0,0,0,1,0,
898,0,0,24,115,0,4,694,0,0,2,1,0,1,0,2,3,0,0,1,9,0,0,
921,0,0,25,170,0,9,713,0,0,1,1,0,1,0,1,9,0,0,
940,0,0,25,0,0,13,719,0,0,3,0,0,1,0,2,9,0,0,2,9,0,0,2,9,0,0,
967,0,0,25,0,0,15,735,0,0,0,0,0,1,0,
982,0,0,26,68,0,4,759,0,0,2,1,0,1,0,2,3,0,0,1,9,0,0,
1005,0,0,27,293,0,9,780,0,0,1,1,0,1,0,1,9,0,0,
1024,0,0,27,0,0,13,787,0,0,4,0,0,1,0,2,9,0,0,2,9,0,0,2,9,0,0,2,9,0,0,
1055,0,0,27,0,0,15,803,0,0,0,0,0,1,0,
1070,0,0,28,151,0,4,829,0,0,4,3,0,1,0,2,3,0,0,1,9,0,0,1,9,0,0,1,9,0,0,
1101,0,0,29,215,0,9,854,0,0,3,3,0,1,0,1,9,0,0,1,9,0,0,1,9,0,0,
1128,0,0,29,0,0,13,861,0,0,4,0,0,1,0,2,9,0,0,2,9,0,0,2,9,0,0,2,9,0,0,
1159,0,0,29,0,0,15,877,0,0,0,0,0,1,0,
1174,0,0,30,67,0,4,899,0,0,2,1,0,1,0,2,3,0,0,1,9,0,0,
1197,0,0,31,150,0,9,919,0,0,1,1,0,1,0,1,9,0,0,
1216,0,0,31,0,0,13,925,0,0,4,0,0,1,0,2,9,0,0,2,9,0,0,2,9,0,0,2,9,0,0,
1247,0,0,31,0,0,15,942,0,0,0,0,0,1,0,
1262,0,0,32,42,0,4,958,0,0,1,0,0,1,0,2,9,0,0,
1281,0,0,33,334,0,4,1005,0,0,14,2,0,1,0,2,9,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,
0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,1,9,0,0,1,9,0,0,
1352,0,0,34,328,0,4,1082,0,0,11,2,0,1,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,0,2,3,0,
0,2,3,0,0,2,3,0,0,2,9,0,0,2,3,0,0,1,9,0,0,1,9,0,0,
1411,0,0,35,197,0,6,1139,0,0,4,4,0,1,0,3,3,0,0,1,9,0,0,2,9,0,0,2,9,0,0,
1442,0,0,36,162,0,6,1178,0,0,3,3,0,1,0,1,9,0,0,1,9,0,0,1,9,0,0,
1469,0,0,37,161,0,6,1218,0,0,4,4,0,1,0,1,9,0,0,1,9,0,0,1,9,0,0,1,9,0,0,
1500,0,0,38,135,0,6,1250,0,0,3,3,0,1,0,1,9,0,0,1,9,0,0,1,9,0,0,
1527,0,0,39,135,0,6,1282,0,0,3,3,0,1,0,1,9,0,0,1,9,0,0,1,9,0,0,
1554,0,0,40,141,0,6,1315,0,0,3,3,0,1,0,1,9,0,0,1,9,0,0,1,9,0,0,
1581,0,0,41,150,0,6,1348,0,0,3,3,0,1,0,1,9,0,0,1,9,0,0,1,9,0,0,
1608,0,0,42,346,0,6,1408,0,0,17,17,0,1,0,1,9,0,0,1,9,0,0,1,9,0,0,1,9,0,0,1,3,0,
0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,0,0,1,3,
0,0,1,9,0,0,1,9,0,0,
1691,0,0,43,47,0,6,1434,0,0,1,1,0,1,0,2,9,0,0,
1710,0,0,44,90,0,6,1465,0,0,2,2,0,1,0,1,9,0,0,1,9,0,0,
};


/***************************************************************************
                          tabmandialog.cpp  -  description
                             -------------------
    begin                : Thu Jan 6 2000
    copyright            : (C) 2000 by Joris Struyve
    email                : j.struyve@village.uunet.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "procinclude.h"

int ConnectToOracle(const char *username,const char *passwd,const char*database,char **ant)

{

 	/* EXEC SQL BEGIN DECLARE SECTION; */ 

 	/* varchar	connectstr[100]; */ 
struct { unsigned short len; unsigned char arr[100]; } connectstr;

 	/* EXEC SQL END DECLARE SECTION; */ 

	
	if(!strcmp(username,"/"))
		sprintf((char*)connectstr.arr,username);
	else
	{
		sprintf((char*)connectstr.arr,username);
		strcat((char*)connectstr.arr,"/");
		strcat((char*)connectstr.arr,passwd);
	}
	
	if(database!=NULL && strcmp(database,"\0"))
	{
		strcat((char*)connectstr.arr,"@");
		strcat((char*)connectstr.arr,database);
	}
	
	connectstr.len = (unsigned short) strlen((char *) connectstr.arr);
	
	/* EXEC SQL WHENEVER SQLERROR CONTINUE; */ 

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/*printf("connecting with : %s",connectstr.arr);fflush(stdout);*/
	/* EXEC SQL CONNECT :connectstr; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )10;
 sqlstm.offset = (unsigned int  )5;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&connectstr;
 sqlstm.sqhstl[0] = (unsigned int  )102;
 sqlstm.sqhsts[0] = (         int  )102;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	return 1;
error:
	SqlError(ant);
	return 0;
}

int ConnectToOracleByString(char const *conn,char **ant)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar connectstr[100]; */ 
struct { unsigned short len; unsigned char arr[100]; } connectstr;

	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char *)connectstr.arr,conn);
	connectstr.len=strlen((char *)connectstr.arr);
	
	/* EXEC SQL WHENEVER SQLERROR CONTINUE; */ 

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/*printf("connecting with : %s",connectstr.arr);*/
	/* EXEC SQL CONNECT :connectstr; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )10;
 sqlstm.offset = (unsigned int  )36;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&connectstr;
 sqlstm.sqhstl[0] = (unsigned int  )102;
 sqlstm.sqhsts[0] = (         int  )102;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(ant);
	return 0;
}


void DisconnectFromOracle()
{
	/* EXEC SQL WHENEVER SQLERROR CONTINUE; */ 

	/* EXEC SQL ROLLBACK WORK RELEASE; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )67;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


}


void SqlError(char **error)
{
	char err_msg[1000];
	size_t buf_len, msg_len;

	/* EXEC SQL WHENEVER SQLERROR CONTINUE; */ 

	buf_len = sizeof (err_msg);
	sqlglm(err_msg, &buf_len, &msg_len);
	
	err_msg[msg_len]=0;
	*error=strdup(err_msg);
}


int GetUserObjects(char ***data1,char ***data2,char ***data3,char ***data4,const char *type,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[129],clm2[8],clm3[19],clm4[20],obt_type[16]; */ 
struct { unsigned short len; unsigned char arr[129]; } clm1;

struct { unsigned short len; unsigned char arr[8]; } clm2;

struct { unsigned short len; unsigned char arr[19]; } clm3;

struct { unsigned short len; unsigned char arr[20]; } clm4;

struct { unsigned short len; unsigned char arr[16]; } obt_type;

	short indic1,indic2,indic3,indic4;
	int aant;	
	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)obt_type.arr,type);
	obt_type.len = strlen((char*)obt_type.arr);
	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM user_objects where object_type = :obt_type; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_objects where object_typ\
e=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )82;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&obt_type;
 sqlstm.sqhstl[1] = (unsigned int  )18;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	*aantal=aant;
	/*printf("aantal %sS in oralib = %d\n",type,*aantal);*/
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	*data2 = (char**)realloc(*data2,aant*sizeof(char*));
	*data3 = (char**)realloc(*data3,aant*sizeof(char*));
	*data4 = (char**)realloc(*data4,aant*sizeof(char*));
	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE objects CURSOR FOR 
	SELECT object_name,status,to_char(created,'dd-mm-yyyy hh24:mi'),timestamp
	FROM user_objects where object_type = :obt_type; */ 

	/* EXEC SQL OPEN objects; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0005;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )105;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&obt_type;
 sqlstm.sqhstl[0] = (unsigned int  )18;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 


	aant = 0;
	for (;;) 
	{ 
			/* EXEC SQL FETCH objects
			INTO :clm1:indic1, :clm2:indic2, :clm3:indic3, :clm4:indic4; */ 

{
   struct sqlexd sqlstm;
   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 4;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )124;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlstm.sqhstv[0] = (         void  *)&clm1;
   sqlstm.sqhstl[0] = (unsigned int  )131;
   sqlstm.sqhsts[0] = (         int  )0;
   sqlstm.sqindv[0] = (         void  *)&indic1;
   sqlstm.sqinds[0] = (         int  )0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqadto[0] = (unsigned short )0;
   sqlstm.sqtdso[0] = (unsigned short )0;
   sqlstm.sqhstv[1] = (         void  *)&clm2;
   sqlstm.sqhstl[1] = (unsigned int  )10;
   sqlstm.sqhsts[1] = (         int  )0;
   sqlstm.sqindv[1] = (         void  *)&indic2;
   sqlstm.sqinds[1] = (         int  )0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqadto[1] = (unsigned short )0;
   sqlstm.sqtdso[1] = (unsigned short )0;
   sqlstm.sqhstv[2] = (         void  *)&clm3;
   sqlstm.sqhstl[2] = (unsigned int  )21;
   sqlstm.sqhsts[2] = (         int  )0;
   sqlstm.sqindv[2] = (         void  *)&indic3;
   sqlstm.sqinds[2] = (         int  )0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqadto[2] = (unsigned short )0;
   sqlstm.sqtdso[2] = (unsigned short )0;
   sqlstm.sqhstv[3] = (         void  *)&clm4;
   sqlstm.sqhstl[3] = (unsigned int  )22;
   sqlstm.sqhsts[3] = (         int  )0;
   sqlstm.sqindv[3] = (         void  *)&indic4;
   sqlstm.sqinds[3] = (         int  )0;
   sqlstm.sqharm[3] = (unsigned int  )0;
   sqlstm.sqadto[3] = (unsigned short )0;
   sqlstm.sqtdso[3] = (unsigned short )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqphss = sqlstm.sqhsts;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqpins = sqlstm.sqinds;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlstm.sqpadto = sqlstm.sqadto;
   sqlstm.sqptdso = sqlstm.sqtdso;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) goto error;
}


			
			indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
			(*data1)[aant]=strdup((char*)clm1.arr);
			
			indic2==-1 ? (clm2.arr[0] = 0) : (clm2.arr[clm2.len] = 0);
			(*data2)[aant]=strdup((char*)clm2.arr);
			
			indic3==-1 ? (clm3.arr[0] = 0) : (clm3.arr[clm3.len] = 0);
			(*data3)[aant]=strdup((char*)clm3.arr);
			
			indic4==-1 ? (clm4.arr[0] = 0) : (clm4.arr[clm4.len] = 0);
			(*data4)[aant]=strdup((char*)clm4.arr);

			aant++;
	}
	/* EXEC SQL CLOSE objects; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )155;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;
	
}


int GetUserTables(char ***data1,char ***data2,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[129],clm2[8]; */ 
struct { unsigned short len; unsigned char arr[129]; } clm1;

struct { unsigned short len; unsigned char arr[8]; } clm2;

	short indic1,indic2;
	int aant;
	/* EXEC SQL END DECLARE SECTION; */ 

	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM user_tables; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_tables ";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )170;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	*aantal=aant;
	
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	*data2 = (char**)realloc(*data2,aant*sizeof(char*));
	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE tables CURSOR FOR 
	SELECT table_name,tablespace_name
	FROM user_tables; */ 

	
	/* EXEC SQL OPEN tables; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0007;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )189;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 


	aant = 0;
	for (;;) 
	{
			/* EXEC SQL FETCH tables
			INTO :clm1:indic1, :clm2:indic2; */ 

{
   struct sqlexd sqlstm;
   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 4;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )204;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlstm.sqhstv[0] = (         void  *)&clm1;
   sqlstm.sqhstl[0] = (unsigned int  )131;
   sqlstm.sqhsts[0] = (         int  )0;
   sqlstm.sqindv[0] = (         void  *)&indic1;
   sqlstm.sqinds[0] = (         int  )0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqadto[0] = (unsigned short )0;
   sqlstm.sqtdso[0] = (unsigned short )0;
   sqlstm.sqhstv[1] = (         void  *)&clm2;
   sqlstm.sqhstl[1] = (unsigned int  )10;
   sqlstm.sqhsts[1] = (         int  )0;
   sqlstm.sqindv[1] = (         void  *)&indic2;
   sqlstm.sqinds[1] = (         int  )0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqadto[1] = (unsigned short )0;
   sqlstm.sqtdso[1] = (unsigned short )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqphss = sqlstm.sqhsts;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqpins = sqlstm.sqinds;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlstm.sqpadto = sqlstm.sqadto;
   sqlstm.sqptdso = sqlstm.sqtdso;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) goto error;
}


			
			indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
			(*data1)[aant]=strdup((char*)clm1.arr);
			
			indic2==-1 ? (clm2.arr[0] = 0) : (clm2.arr[clm2.len] = 0);
			(*data2)[aant]=strdup((char*)clm2.arr);
			
			aant++;
	}
	/* EXEC SQL CLOSE tables; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )227;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;
	
}


int GetIndexDetails(char ***data1,char ***data2,const char *index,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[31],clm2[4001],ind_name[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } clm1;

struct { unsigned short len; unsigned char arr[4001]; } clm2;

struct { unsigned short len; unsigned char arr[31]; } ind_name;

	short indic1,indic2;
	int aant;
	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)ind_name.arr,index);
	ind_name.len = strlen((char*)ind_name.arr);

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM user_ind_columns where index_name = :ind_name; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_ind_columns where index_\
name=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )242;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&ind_name;
 sqlstm.sqhstl[1] = (unsigned int  )33;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	*aantal=aant;
	
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	*data2 = (char**)realloc(*data2,aant*sizeof(char*));
	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE inddet CURSOR FOR 
	SELECT table_name,column_name
	FROM user_ind_columns
	WHERE index_name = :ind_name; */ 

	
	/* EXEC SQL OPEN inddet; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0009;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )265;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&ind_name;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 


	aant = 0;
	for (;;) 
	{
			/* EXEC SQL FETCH inddet
			INTO :clm1:indic1, :clm2:indic2; */ 

{
   struct sqlexd sqlstm;
   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 4;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )284;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlstm.sqhstv[0] = (         void  *)&clm1;
   sqlstm.sqhstl[0] = (unsigned int  )33;
   sqlstm.sqhsts[0] = (         int  )0;
   sqlstm.sqindv[0] = (         void  *)&indic1;
   sqlstm.sqinds[0] = (         int  )0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqadto[0] = (unsigned short )0;
   sqlstm.sqtdso[0] = (unsigned short )0;
   sqlstm.sqhstv[1] = (         void  *)&clm2;
   sqlstm.sqhstl[1] = (unsigned int  )4003;
   sqlstm.sqhsts[1] = (         int  )0;
   sqlstm.sqindv[1] = (         void  *)&indic2;
   sqlstm.sqinds[1] = (         int  )0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqadto[1] = (unsigned short )0;
   sqlstm.sqtdso[1] = (unsigned short )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqphss = sqlstm.sqhsts;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqpins = sqlstm.sqinds;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlstm.sqpadto = sqlstm.sqadto;
   sqlstm.sqptdso = sqlstm.sqtdso;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) goto error;
}


			
			(*data2)[aant]=strdup((char*)clm2.arr);
			indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
			(*data1)[aant]=strdup((char*)clm1.arr);
			
			indic2==-1 ? (clm2.arr[0] = 0) : (clm2.arr[clm2.len] = 0);
			(*data2)[aant]=strdup((char*)clm2.arr);

			aant++;
	}
	/* EXEC SQL CLOSE inddet; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )307;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;
	
}


int GetUserIndexes(char ***data1,char ***data2,char ***data3,char ***data4,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[31],clm2[13],clm3[31],clm4[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } clm1;

struct { unsigned short len; unsigned char arr[13]; } clm2;

struct { unsigned short len; unsigned char arr[31]; } clm3;

struct { unsigned short len; unsigned char arr[31]; } clm4;

	short indic1,indic2,indic3,indic4;
	int aant;
	/* EXEC SQL END DECLARE SECTION; */ 

		
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM user_indexes; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_indexes ";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )322;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	*aantal=aant;
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	*data2 = (char**)realloc(*data2,aant*sizeof(char*));
	*data3 = (char**)realloc(*data3,aant*sizeof(char*));
	*data4 = (char**)realloc(*data4,aant*sizeof(char*));
		
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE ind CURSOR FOR 
	SELECT index_name,index_type,table_name,tablespace_name
	FROM user_indexes; */ 

	/* EXEC SQL OPEN ind; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0011;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )341;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 


	aant = 0;
	for (;;) 
	{
			/* EXEC SQL FETCH ind
			INTO :clm1:indic1, :clm2:indic2, :clm3:indic3,:clm4:indic4; */ 

{
   struct sqlexd sqlstm;
   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 4;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )356;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlstm.sqhstv[0] = (         void  *)&clm1;
   sqlstm.sqhstl[0] = (unsigned int  )33;
   sqlstm.sqhsts[0] = (         int  )0;
   sqlstm.sqindv[0] = (         void  *)&indic1;
   sqlstm.sqinds[0] = (         int  )0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqadto[0] = (unsigned short )0;
   sqlstm.sqtdso[0] = (unsigned short )0;
   sqlstm.sqhstv[1] = (         void  *)&clm2;
   sqlstm.sqhstl[1] = (unsigned int  )15;
   sqlstm.sqhsts[1] = (         int  )0;
   sqlstm.sqindv[1] = (         void  *)&indic2;
   sqlstm.sqinds[1] = (         int  )0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqadto[1] = (unsigned short )0;
   sqlstm.sqtdso[1] = (unsigned short )0;
   sqlstm.sqhstv[2] = (         void  *)&clm3;
   sqlstm.sqhstl[2] = (unsigned int  )33;
   sqlstm.sqhsts[2] = (         int  )0;
   sqlstm.sqindv[2] = (         void  *)&indic3;
   sqlstm.sqinds[2] = (         int  )0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqadto[2] = (unsigned short )0;
   sqlstm.sqtdso[2] = (unsigned short )0;
   sqlstm.sqhstv[3] = (         void  *)&clm4;
   sqlstm.sqhstl[3] = (unsigned int  )33;
   sqlstm.sqhsts[3] = (         int  )0;
   sqlstm.sqindv[3] = (         void  *)&indic4;
   sqlstm.sqinds[3] = (         int  )0;
   sqlstm.sqharm[3] = (unsigned int  )0;
   sqlstm.sqadto[3] = (unsigned short )0;
   sqlstm.sqtdso[3] = (unsigned short )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqphss = sqlstm.sqhsts;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqpins = sqlstm.sqinds;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlstm.sqpadto = sqlstm.sqadto;
   sqlstm.sqptdso = sqlstm.sqtdso;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) goto error;
}



			indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
			(*data1)[aant]=strdup((char*)clm1.arr);
			
			indic2==-1 ? (clm2.arr[0] = 0) : (clm2.arr[clm2.len] = 0);
			(*data2)[aant]=strdup((char*)clm2.arr);
			
			indic3==-1 ? (clm3.arr[0] = 0) : (clm3.arr[clm3.len] = 0);
			(*data3)[aant]=strdup((char*)clm3.arr);
			
			indic4==-1 ? (clm4.arr[0] = 0) : (clm4.arr[clm4.len] = 0);
			(*data4)[aant]=strdup((char*)clm4.arr);

			aant++;
	}
	/* EXEC SQL CLOSE ind; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )387;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;
	
}


int GetUserObjectsName(char ***data1,const char *type,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[129],obt_type[16]; */ 
struct { unsigned short len; unsigned char arr[129]; } clm1;

struct { unsigned short len; unsigned char arr[16]; } obt_type;

	short indic1;
	int aant;	
	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)obt_type.arr,type);
	obt_type.len = strlen((char*)obt_type.arr);
	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM user_objects where object_type = :obt_type; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_objects where object_typ\
e=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )402;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&obt_type;
 sqlstm.sqhstl[1] = (unsigned int  )18;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	*aantal=aant;
	/*printf("aantal %sS in oralib = %d\n",type,*aantal);*/
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL DECLARE objectsname CURSOR FOR 
	SELECT object_name
	FROM user_objects
	WHERE object_type = :obt_type
	ORDER BY 1 DESC; */ 

	
	/* EXEC SQL OPEN objectsname; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0013;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )425;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&obt_type;
 sqlstm.sqhstl[0] = (unsigned int  )18;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 


	aant = 0;
	for (;;) 
	{ 
			/* EXEC SQL FETCH objectsname
			INTO :clm1:indic1; */ 

{
   struct sqlexd sqlstm;
   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 4;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )444;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlstm.sqhstv[0] = (         void  *)&clm1;
   sqlstm.sqhstl[0] = (unsigned int  )131;
   sqlstm.sqhsts[0] = (         int  )0;
   sqlstm.sqindv[0] = (         void  *)&indic1;
   sqlstm.sqinds[0] = (         int  )0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqadto[0] = (unsigned short )0;
   sqlstm.sqtdso[0] = (unsigned short )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqphss = sqlstm.sqhsts;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqpins = sqlstm.sqinds;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlstm.sqpadto = sqlstm.sqadto;
   sqlstm.sqptdso = sqlstm.sqtdso;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) goto error;
}



			indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
			(*data1)[aant]=strdup((char*)clm1.arr);
			
			aant++;
	}
	/* EXEC SQL CLOSE objectsname; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )463;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;
	
}

int GetAllUserObjects(char ***data1,char ***data2,char ***data3,char ***data4,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[129],clm2[16],clm3[8],clm4[19]; */ 
struct { unsigned short len; unsigned char arr[129]; } clm1;

struct { unsigned short len; unsigned char arr[16]; } clm2;

struct { unsigned short len; unsigned char arr[8]; } clm3;

struct { unsigned short len; unsigned char arr[19]; } clm4;

	short indic1,indic2,indic3,indic4;
	int aant;
	/* EXEC SQL END DECLARE SECTION; */ 

	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM user_objects; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_objects ";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )478;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	*aantal=aant;
	/*printf("aantal objects in oralib = %d\n",*aantal);*/
	
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	*data2 = (char**)realloc(*data2,aant*sizeof(char*));
	*data3 = (char**)realloc(*data3,aant*sizeof(char*));
	*data4 = (char**)realloc(*data4,aant*sizeof(char*));
	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE allobjects CURSOR FOR 
	SELECT object_name,object_type,status,to_char(created,'dd-mm-yyyy hh24:mi') FROM user_objects; */ 

	/* EXEC SQL OPEN allobjects; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0015;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )497;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 


	aant = 0;
	for (;;) 
	{ 
			/* EXEC SQL FETCH allobjects
			INTO :clm1:indic1, :clm2:indic2, :clm3:indic3, :clm4:indic4; */ 

{
   struct sqlexd sqlstm;
   sqlstm.sqlvsn = 10;
   sqlstm.arrsiz = 4;
   sqlstm.sqladtp = &sqladt;
   sqlstm.sqltdsp = &sqltds;
   sqlstm.iters = (unsigned int  )1;
   sqlstm.offset = (unsigned int  )512;
   sqlstm.cud = sqlcud0;
   sqlstm.sqlest = (unsigned char  *)&sqlca;
   sqlstm.sqlety = (unsigned short)256;
   sqlstm.occurs = (unsigned int  )0;
   sqlstm.sqhstv[0] = (         void  *)&clm1;
   sqlstm.sqhstl[0] = (unsigned int  )131;
   sqlstm.sqhsts[0] = (         int  )0;
   sqlstm.sqindv[0] = (         void  *)&indic1;
   sqlstm.sqinds[0] = (         int  )0;
   sqlstm.sqharm[0] = (unsigned int  )0;
   sqlstm.sqadto[0] = (unsigned short )0;
   sqlstm.sqtdso[0] = (unsigned short )0;
   sqlstm.sqhstv[1] = (         void  *)&clm2;
   sqlstm.sqhstl[1] = (unsigned int  )18;
   sqlstm.sqhsts[1] = (         int  )0;
   sqlstm.sqindv[1] = (         void  *)&indic2;
   sqlstm.sqinds[1] = (         int  )0;
   sqlstm.sqharm[1] = (unsigned int  )0;
   sqlstm.sqadto[1] = (unsigned short )0;
   sqlstm.sqtdso[1] = (unsigned short )0;
   sqlstm.sqhstv[2] = (         void  *)&clm3;
   sqlstm.sqhstl[2] = (unsigned int  )10;
   sqlstm.sqhsts[2] = (         int  )0;
   sqlstm.sqindv[2] = (         void  *)&indic3;
   sqlstm.sqinds[2] = (         int  )0;
   sqlstm.sqharm[2] = (unsigned int  )0;
   sqlstm.sqadto[2] = (unsigned short )0;
   sqlstm.sqtdso[2] = (unsigned short )0;
   sqlstm.sqhstv[3] = (         void  *)&clm4;
   sqlstm.sqhstl[3] = (unsigned int  )21;
   sqlstm.sqhsts[3] = (         int  )0;
   sqlstm.sqindv[3] = (         void  *)&indic4;
   sqlstm.sqinds[3] = (         int  )0;
   sqlstm.sqharm[3] = (unsigned int  )0;
   sqlstm.sqadto[3] = (unsigned short )0;
   sqlstm.sqtdso[3] = (unsigned short )0;
   sqlstm.sqphsv = sqlstm.sqhstv;
   sqlstm.sqphsl = sqlstm.sqhstl;
   sqlstm.sqphss = sqlstm.sqhsts;
   sqlstm.sqpind = sqlstm.sqindv;
   sqlstm.sqpins = sqlstm.sqinds;
   sqlstm.sqparm = sqlstm.sqharm;
   sqlstm.sqparc = sqlstm.sqharc;
   sqlstm.sqpadto = sqlstm.sqadto;
   sqlstm.sqptdso = sqlstm.sqtdso;
   sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
   if (sqlca.sqlcode == 1403) break;
   if (sqlca.sqlcode < 0) goto error;
}


			
			indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
			(*data1)[aant]=strdup((char*)clm1.arr);
			
			indic2==-1 ? (clm2.arr[0] = 0) : (clm2.arr[clm2.len] = 0);
			(*data2)[aant]=strdup((char*)clm2.arr);
			
			indic3==-1 ? (clm3.arr[0] = 0) : (clm3.arr[clm3.len] = 0);
			(*data3)[aant]=strdup((char*)clm3.arr);
			
			indic4==-1 ? (clm4.arr[0] = 0) : (clm4.arr[clm4.len] = 0);
			(*data4)[aant]=strdup((char*)clm4.arr);

			aant++;
	}
	/* EXEC SQL CLOSE allobjects; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )543;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;	
}

int GetTableColumns(char ***data,const char *table,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[129],tablename[129]; */ 
struct { unsigned short len; unsigned char arr[129]; } clm1;

struct { unsigned short len; unsigned char arr[129]; } tablename;

	short indic;
	int aant;	
	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)tablename.arr,table);
	tablename.len = strlen((char*)tablename.arr);
	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM  user_tab_columns WHERE table_name = :tablename; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_tab_columns where table_\
name=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )558;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&tablename;
 sqlstm.sqhstl[1] = (unsigned int  )131;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	*aantal=aant;
	/*printf("aantal COLUMNS in oralib = %d\n",*aantal);*/
	*data = (char**)realloc(*data,aant*sizeof(char*));
	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE cols CURSOR FOR 
	SELECT column_name FROM user_tab_columns WHERE table_name = :tablename; */ 

	/* EXEC SQL OPEN cols; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0017;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )581;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&tablename;
 sqlstm.sqhstl[0] = (unsigned int  )131;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 


	aant = 0;
	for (;;) 
	{ 
		/* EXEC SQL FETCH cols INTO :clm1:indic; */ 

{
  struct sqlexd sqlstm;
  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )600;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlstm.sqhstv[0] = (         void  *)&clm1;
  sqlstm.sqhstl[0] = (unsigned int  )131;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)&indic;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) goto error;
}


		if (indic!=-1)
		{
			clm1.arr[clm1.len] = 0;
			(*data)[aant++]=strdup((char*)clm1.arr);
		}
	}
	/* EXEC SQL CLOSE cols; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )619;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;	
}


int GetTableIndexDetails(char ***data1,char ***data2,char ***data3,char ***data4,const char *table,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[31],clm2[13],clm3[10],clm4[4000],tablename[129]; */ 
struct { unsigned short len; unsigned char arr[31]; } clm1;

struct { unsigned short len; unsigned char arr[13]; } clm2;

struct { unsigned short len; unsigned char arr[10]; } clm3;

struct { unsigned short len; unsigned char arr[4000]; } clm4;

struct { unsigned short len; unsigned char arr[129]; } tablename;

	short indic1,indic2,indic3,indic4;
	int aant;	
	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)tablename.arr,table);
	tablename.len = strlen((char*)tablename.arr);
	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM  user_indexes
		 WHERE table_name = :tablename; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_indexes where table_name\
=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )634;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&tablename;
 sqlstm.sqhstl[1] = (unsigned int  )131;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	*aantal=aant;
	/*printf("aantal indexes in oralib = %d\n",*aantal);*/
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	*data2 = (char**)realloc(*data2,aant*sizeof(char*));
	*data3 = (char**)realloc(*data3,aant*sizeof(char*));
	*data4 = (char**)realloc(*data4,aant*sizeof(char*));

	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE indtabdet CURSOR FOR 
	SELECT index_name,index_type,uniqueness,tablespace_name
	FROM user_indexes
	WHERE table_name = :tablename; */ 

	/* EXEC SQL OPEN indtabdet; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0019;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )657;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&tablename;
 sqlstm.sqhstl[0] = (unsigned int  )131;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 


	aant = 0;
	for (;;) 
	{ 
		/* EXEC SQL FETCH indtabdet
		INTO :clm1:indic1, :clm2:indic2, :clm3:indic3, :clm4:indic4; */ 

{
  struct sqlexd sqlstm;
  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )676;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlstm.sqhstv[0] = (         void  *)&clm1;
  sqlstm.sqhstl[0] = (unsigned int  )33;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)&indic1;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqhstv[1] = (         void  *)&clm2;
  sqlstm.sqhstl[1] = (unsigned int  )15;
  sqlstm.sqhsts[1] = (         int  )0;
  sqlstm.sqindv[1] = (         void  *)&indic2;
  sqlstm.sqinds[1] = (         int  )0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqadto[1] = (unsigned short )0;
  sqlstm.sqtdso[1] = (unsigned short )0;
  sqlstm.sqhstv[2] = (         void  *)&clm3;
  sqlstm.sqhstl[2] = (unsigned int  )12;
  sqlstm.sqhsts[2] = (         int  )0;
  sqlstm.sqindv[2] = (         void  *)&indic3;
  sqlstm.sqinds[2] = (         int  )0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqadto[2] = (unsigned short )0;
  sqlstm.sqtdso[2] = (unsigned short )0;
  sqlstm.sqhstv[3] = (         void  *)&clm4;
  sqlstm.sqhstl[3] = (unsigned int  )4002;
  sqlstm.sqhsts[3] = (         int  )0;
  sqlstm.sqindv[3] = (         void  *)&indic4;
  sqlstm.sqinds[3] = (         int  )0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqadto[3] = (unsigned short )0;
  sqlstm.sqtdso[3] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) goto error;
}


		if (indic1!=-1)
		{

			indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
			(*data1)[aant]=strdup((char*)clm1.arr);
			
			indic2==-1 ? (clm2.arr[0] = 0) : (clm2.arr[clm2.len] = 0);
			(*data2)[aant]=strdup((char*)clm2.arr);
			
			indic3==-1 ? (clm3.arr[0] = 0) : (clm3.arr[clm3.len] = 0);
			(*data3)[aant]=strdup((char*)clm3.arr);
			
			indic4==-1 ? (clm4.arr[0] = 0) : (clm4.arr[clm4.len] = 0);
			(*data4)[aant]=strdup((char*)clm4.arr);

			aant++;
		}
	}
	/* EXEC SQL CLOSE indtabdet; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )707;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;	
}

int GetTableConstraintDetails(char ***data1,char ***data2,char ***data3,char ***data4,const char *table,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[31],clm2[2],clm3[10],clm4[4000],tablename[129]; */ 
struct { unsigned short len; unsigned char arr[31]; } clm1;

struct { unsigned short len; unsigned char arr[2]; } clm2;

struct { unsigned short len; unsigned char arr[10]; } clm3;

struct { unsigned short len; unsigned char arr[4000]; } clm4;

struct { unsigned short len; unsigned char arr[129]; } tablename;

	short indic1,indic2,indic3,indic4;
	int aant;	
	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)tablename.arr,table);
	tablename.len = strlen((char*)tablename.arr);
	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM  user_constraints
		 WHERE table_name = :tablename; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_constraints where table_\
name=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )722;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&tablename;
 sqlstm.sqhstl[1] = (unsigned int  )131;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	*aantal=aant;
	/*printf("aantal COLUMNS in oralib = %d\n",*aantal);*/
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	*data2 = (char**)realloc(*data2,aant*sizeof(char*));
	*data3 = (char**)realloc(*data3,aant*sizeof(char*));
	*data4 = (char**)realloc(*data4,aant*sizeof(char*));
	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE constdet CURSOR FOR 
	SELECT constraint_name,constraint_type,status,delete_rule
	FROM user_constraints
	WHERE table_name = :tablename; */ 

	/* EXEC SQL OPEN constdet; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0021;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )745;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&tablename;
 sqlstm.sqhstl[0] = (unsigned int  )131;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 


	aant = 0;
	for (;;) 
	{ 
		/* EXEC SQL FETCH constdet
		INTO :clm1:indic1, :clm2:indic2, :clm3:indic3, :clm4:indic4; */ 

{
  struct sqlexd sqlstm;
  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )764;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlstm.sqhstv[0] = (         void  *)&clm1;
  sqlstm.sqhstl[0] = (unsigned int  )33;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)&indic1;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqhstv[1] = (         void  *)&clm2;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqhsts[1] = (         int  )0;
  sqlstm.sqindv[1] = (         void  *)&indic2;
  sqlstm.sqinds[1] = (         int  )0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqadto[1] = (unsigned short )0;
  sqlstm.sqtdso[1] = (unsigned short )0;
  sqlstm.sqhstv[2] = (         void  *)&clm3;
  sqlstm.sqhstl[2] = (unsigned int  )12;
  sqlstm.sqhsts[2] = (         int  )0;
  sqlstm.sqindv[2] = (         void  *)&indic3;
  sqlstm.sqinds[2] = (         int  )0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqadto[2] = (unsigned short )0;
  sqlstm.sqtdso[2] = (unsigned short )0;
  sqlstm.sqhstv[3] = (         void  *)&clm4;
  sqlstm.sqhstl[3] = (unsigned int  )4002;
  sqlstm.sqhsts[3] = (         int  )0;
  sqlstm.sqindv[3] = (         void  *)&indic4;
  sqlstm.sqinds[3] = (         int  )0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqadto[3] = (unsigned short )0;
  sqlstm.sqtdso[3] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) goto error;
}


		if (indic1!=-1)
		{
			indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
			(*data1)[aant]=strdup((char*)clm1.arr);
			
			indic2==-1 ? (clm2.arr[0] = 0) : (clm2.arr[clm2.len] = 0);
			(*data2)[aant]=strdup((char*)clm2.arr);
			
			indic3==-1 ? (clm3.arr[0] = 0) : (clm3.arr[clm3.len] = 0);
			(*data3)[aant]=strdup((char*)clm3.arr);
			
			indic4==-1 ? (clm4.arr[0] = 0) : (clm4.arr[clm4.len] = 0);
			(*data4)[aant]=strdup((char*)clm4.arr);
			aant++;
		}
	}
	/* EXEC SQL CLOSE constdet; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )795;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;	
}


int GetTableTriggerDetails(char ***data1,char ***data2,char ***data3,char ***data4,const char *table,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[31],clm2[2],clm3[10],clm4[4000],tablename[129]; */ 
struct { unsigned short len; unsigned char arr[31]; } clm1;

struct { unsigned short len; unsigned char arr[2]; } clm2;

struct { unsigned short len; unsigned char arr[10]; } clm3;

struct { unsigned short len; unsigned char arr[4000]; } clm4;

struct { unsigned short len; unsigned char arr[129]; } tablename;

	short indic1,indic2,indic3,indic4;
	int aant;	
	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)tablename.arr,table);
	tablename.len = strlen((char*)tablename.arr);
	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM  user_triggers
		 WHERE table_name = :tablename; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_triggers where table_nam\
e=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )810;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&tablename;
 sqlstm.sqhstl[1] = (unsigned int  )131;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	*aantal=aant;
	/*printf("aantal COLUMNS in oralib = %d\n",*aantal);*/
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	*data2 = (char**)realloc(*data2,aant*sizeof(char*));
	*data3 = (char**)realloc(*data3,aant*sizeof(char*));
	*data4 = (char**)realloc(*data4,aant*sizeof(char*));
	

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE trigdet CURSOR FOR 
	SELECT trigger_name,trigger_type,status,triggering_event
	FROM user_triggers
	WHERE table_name = :tablename; */ 

	
	/* EXEC SQL OPEN trigdet; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0023;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )833;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&tablename;
 sqlstm.sqhstl[0] = (unsigned int  )131;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 


	aant = 0;
	for (;;) 
	{ 
		/* EXEC SQL FETCH trigdet 
		INTO :clm1:indic1, :clm2:indic2, :clm3:indic3, :clm4:indic4; */ 

{
  struct sqlexd sqlstm;
  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )852;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlstm.sqhstv[0] = (         void  *)&clm1;
  sqlstm.sqhstl[0] = (unsigned int  )33;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)&indic1;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqhstv[1] = (         void  *)&clm2;
  sqlstm.sqhstl[1] = (unsigned int  )4;
  sqlstm.sqhsts[1] = (         int  )0;
  sqlstm.sqindv[1] = (         void  *)&indic2;
  sqlstm.sqinds[1] = (         int  )0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqadto[1] = (unsigned short )0;
  sqlstm.sqtdso[1] = (unsigned short )0;
  sqlstm.sqhstv[2] = (         void  *)&clm3;
  sqlstm.sqhstl[2] = (unsigned int  )12;
  sqlstm.sqhsts[2] = (         int  )0;
  sqlstm.sqindv[2] = (         void  *)&indic3;
  sqlstm.sqinds[2] = (         int  )0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqadto[2] = (unsigned short )0;
  sqlstm.sqtdso[2] = (unsigned short )0;
  sqlstm.sqhstv[3] = (         void  *)&clm4;
  sqlstm.sqhstl[3] = (unsigned int  )4002;
  sqlstm.sqhsts[3] = (         int  )0;
  sqlstm.sqindv[3] = (         void  *)&indic4;
  sqlstm.sqinds[3] = (         int  )0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqadto[3] = (unsigned short )0;
  sqlstm.sqtdso[3] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) goto error;
}


		if (indic1!=-1)
		{

			indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
			(*data1)[aant]=strdup((char*)clm1.arr);
			
			indic2==-1 ? (clm2.arr[0] = 0) : (clm2.arr[clm2.len] = 0);
			(*data2)[aant]=strdup((char*)clm2.arr);
			
			indic3==-1 ? (clm3.arr[0] = 0) : (clm3.arr[clm3.len] = 0);
			(*data3)[aant]=strdup((char*)clm3.arr);
			
			indic4==-1 ? (clm4.arr[0] = 0) : (clm4.arr[clm4.len] = 0);
			(*data4)[aant]=strdup((char*)clm4.arr);

			aant++;
		}
	}
	/* EXEC SQL CLOSE trigdet; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )883;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;	
}

int GetPackageBodyNames(char ***data1,char ***data2,char ***data3,const char *package,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[129],clm2[41],clm3[129],packagename[129]; */ 
struct { unsigned short len; unsigned char arr[129]; } clm1;

struct { unsigned short len; unsigned char arr[41]; } clm2;

struct { unsigned short len; unsigned char arr[129]; } clm3;

struct { unsigned short len; unsigned char arr[129]; } packagename;

	short indic1,indic2,indic3;
	int aant;
	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)packagename.arr,package);
	packagename.len = strlen((char*)packagename.arr);
	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(count(object_name))
		 INTO :aant
		 FROM  user_arguments
		 WHERE package_name = :packagename
		 GROUP BY object_name,overload; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(count(object_name)) into :b0  from user_argumen\
ts where package_name=:b1 group by object_name,overload";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )898;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&packagename;
 sqlstm.sqhstl[1] = (unsigned int  )131;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	*aantal=aant;
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	*data2 = (char**)realloc(*data2,aant*sizeof(char*));
	*data3 = (char**)realloc(*data3,aant*sizeof(char*));
	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE bodies CURSOR FOR 
	SELECT  object_name,overload,object_name||'('||overload||')'
	FROM user_arguments
	WHERE package_name = :packagename
	GROUP BY object_name,overload
	ORDER BY 1 DESC; */ 

	
	/* EXEC SQL OPEN bodies; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0025;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )921;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&packagename;
 sqlstm.sqhstl[0] = (unsigned int  )131;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	aant = 0;
	for (;;) 
	{ 
		/* EXEC SQL FETCH bodies INTO :clm1:indic1,clm2:indic2,clm3:indic3; */ 

{
  struct sqlexd sqlstm;
  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )940;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlstm.sqhstv[0] = (         void  *)&clm1;
  sqlstm.sqhstl[0] = (unsigned int  )131;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)&indic1;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqhstv[1] = (         void  *)&clm2;
  sqlstm.sqhstl[1] = (unsigned int  )43;
  sqlstm.sqhsts[1] = (         int  )0;
  sqlstm.sqindv[1] = (         void  *)&indic2;
  sqlstm.sqinds[1] = (         int  )0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqadto[1] = (unsigned short )0;
  sqlstm.sqtdso[1] = (unsigned short )0;
  sqlstm.sqhstv[2] = (         void  *)&clm3;
  sqlstm.sqhstl[2] = (unsigned int  )131;
  sqlstm.sqhsts[2] = (         int  )0;
  sqlstm.sqindv[2] = (         void  *)&indic3;
  sqlstm.sqinds[2] = (         int  )0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqadto[2] = (unsigned short )0;
  sqlstm.sqtdso[2] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) goto error;
}


		if (indic1!=-1)
		{

			indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
			(*data1)[aant]=strdup((char*)clm1.arr);
			
			indic2==-1 ? (clm2.arr[0] = 0) : (clm2.arr[clm2.len] = 0);
			(*data2)[aant]=strdup((char*)clm2.arr);
			
			indic3==-1 ? (clm3.arr[0] = 0) : (clm3.arr[clm3.len] = 0);
			(*data3)[aant]=strdup((char*)clm3.arr);

			aant++;
		}
	}
	/* EXEC SQL CLOSE bodies; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )967;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
	
error:
	SqlError(resp);
	return 0;	
}


int GetTableColumnDetails(char ***data1,char ***data2,char ***data3,char ***data4,const char *table,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[31],clm2[31],clm3[31],clm4[4001],tablename[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } clm1;

struct { unsigned short len; unsigned char arr[31]; } clm2;

struct { unsigned short len; unsigned char arr[31]; } clm3;

struct { unsigned short len; unsigned char arr[4001]; } clm4;

struct { unsigned short len; unsigned char arr[31]; } tablename;

	short indic1,indic2,indic3,indic4;
	int aant;
	/* EXEC SQL END DECLARE SECTION; */ 

	
	
	strcpy((char*)tablename.arr,table);
	tablename.len = strlen((char*)tablename.arr);
	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM  user_tab_columns WHERE table_name = :tablename; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_tab_columns where table_\
name=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )982;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&tablename;
 sqlstm.sqhstl[1] = (unsigned int  )33;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	*aantal=aant;
	/*printf("aantal COLUMNS in oralib = %d\n",*aantal);*/
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	*data2 = (char**)realloc(*data2,aant*sizeof(char*));
	*data3 = (char**)realloc(*data3,aant*sizeof(char*));
	*data4 = (char**)realloc(*data4,aant*sizeof(char*));
	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE coldet CURSOR FOR 
	SELECT utc.column_name,
		   utc.data_type,
		   decode(data_type,'NUMBER',to_char(data_precision)||','||to_char(data_scale)),
		   ucc.comments
	FROM user_tab_columns utc,user_col_comments ucc
	WHERE utc.table_name = :tablename
	  and ucc.column_name = utc.column_name
	  and ucc.table_name = utc.table_name; */ 

	/* EXEC SQL OPEN coldet; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0027;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1005;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&tablename;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 


	aant = 0;
	for (;;) 
	{
		/* EXEC SQL FETCH coldet
		INTO :clm1:indic1, :clm2:indic2, :clm3:indic3, :clm4:indic4; */ 

{
  struct sqlexd sqlstm;
  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )1024;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlstm.sqhstv[0] = (         void  *)&clm1;
  sqlstm.sqhstl[0] = (unsigned int  )33;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)&indic1;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqhstv[1] = (         void  *)&clm2;
  sqlstm.sqhstl[1] = (unsigned int  )33;
  sqlstm.sqhsts[1] = (         int  )0;
  sqlstm.sqindv[1] = (         void  *)&indic2;
  sqlstm.sqinds[1] = (         int  )0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqadto[1] = (unsigned short )0;
  sqlstm.sqtdso[1] = (unsigned short )0;
  sqlstm.sqhstv[2] = (         void  *)&clm3;
  sqlstm.sqhstl[2] = (unsigned int  )33;
  sqlstm.sqhsts[2] = (         int  )0;
  sqlstm.sqindv[2] = (         void  *)&indic3;
  sqlstm.sqinds[2] = (         int  )0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqadto[2] = (unsigned short )0;
  sqlstm.sqtdso[2] = (unsigned short )0;
  sqlstm.sqhstv[3] = (         void  *)&clm4;
  sqlstm.sqhstl[3] = (unsigned int  )4003;
  sqlstm.sqhsts[3] = (         int  )0;
  sqlstm.sqindv[3] = (         void  *)&indic4;
  sqlstm.sqinds[3] = (         int  )0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqadto[3] = (unsigned short )0;
  sqlstm.sqtdso[3] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) goto error;
}



                indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
                (*data1)[aant]=strdup((char*)clm1.arr);
                
                indic2==-1 ? (clm2.arr[0] = 0) : (clm2.arr[clm2.len] = 0);
                (*data2)[aant]=strdup((char*)clm2.arr);
                
                indic3==-1 ? (clm3.arr[0] = 0) : (clm3.arr[clm3.len] = 0);
                (*data3)[aant]=strdup((char*)clm3.arr);
                
                indic4==-1 ? (clm4.arr[0] = 0) : (clm4.arr[clm4.len] = 0);
                (*data4)[aant]=strdup((char*)clm4.arr);
		aant++;
	}
	/* EXEC SQL CLOSE coldet; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1055;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;	
}


int GetBodyArguments(char ***data1,char ***data2,char ***data3,char ***data4,const char *package,const char *body,const char *ol,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[31],clm2[15],clm3[10],clm4[39],packagename[31],bodyname[31],ol_nr[41]; */ 
struct { unsigned short len; unsigned char arr[31]; } clm1;

struct { unsigned short len; unsigned char arr[15]; } clm2;

struct { unsigned short len; unsigned char arr[10]; } clm3;

struct { unsigned short len; unsigned char arr[39]; } clm4;

struct { unsigned short len; unsigned char arr[31]; } packagename;

struct { unsigned short len; unsigned char arr[31]; } bodyname;

struct { unsigned short len; unsigned char arr[41]; } ol_nr;

	short indic1,indic2,indic3,indic4;
	int aant;	
	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)packagename.arr,package);
	packagename.len = strlen((char*)packagename.arr);
	strcpy((char*)bodyname.arr,body);
	bodyname.len = strlen((char*)bodyname.arr);
	strcpy((char*)ol_nr.arr,ol);
	ol_nr.len = strlen((char*)ol_nr.arr);
	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM  user_arguments
		 WHERE package_name = :packagename
		   and object_name = :bodyname
		   and (overload = :ol_nr or overload is null)
		   and data_level = 0; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_arguments where (((packa\
ge_name=:b1 and object_name=:b2) and (overload=:b3 or overload is null )) and \
data_level=0)";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1070;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&packagename;
 sqlstm.sqhstl[1] = (unsigned int  )33;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&bodyname;
 sqlstm.sqhstl[2] = (unsigned int  )33;
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqhstv[3] = (         void  *)&ol_nr;
 sqlstm.sqhstl[3] = (unsigned int  )43;
 sqlstm.sqhsts[3] = (         int  )0;
 sqlstm.sqindv[3] = (         void  *)0;
 sqlstm.sqinds[3] = (         int  )0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqadto[3] = (unsigned short )0;
 sqlstm.sqtdso[3] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	

	*aantal=aant;
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	*data2 = (char**)realloc(*data2,aant*sizeof(char*));
	*data3 = (char**)realloc(*data3,aant*sizeof(char*));
	*data4 = (char**)realloc(*data4,aant*sizeof(char*));
	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE bobyargs CURSOR FOR 
	SELECT argument_name,data_type,in_out,to_char(position)
	FROM user_arguments
	WHERE package_name = :packagename
	   and object_name = :bodyname
	   and (overload = :ol_nr or overload is null)
	   and data_level = 0
	 ORDER BY position; */ 

	   
	/* EXEC SQL OPEN bobyargs; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0029;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1101;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&packagename;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&bodyname;
 sqlstm.sqhstl[1] = (unsigned int  )33;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&ol_nr;
 sqlstm.sqhstl[2] = (unsigned int  )43;
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 


	aant = 0;
	for (;;) 
	{
		/* EXEC SQL FETCH bobyargs
		INTO :clm1:indic1, :clm2:indic2, :clm3:indic3, :clm4:indic4; */ 

{
  struct sqlexd sqlstm;
  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )1128;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlstm.sqhstv[0] = (         void  *)&clm1;
  sqlstm.sqhstl[0] = (unsigned int  )33;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)&indic1;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqhstv[1] = (         void  *)&clm2;
  sqlstm.sqhstl[1] = (unsigned int  )17;
  sqlstm.sqhsts[1] = (         int  )0;
  sqlstm.sqindv[1] = (         void  *)&indic2;
  sqlstm.sqinds[1] = (         int  )0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqadto[1] = (unsigned short )0;
  sqlstm.sqtdso[1] = (unsigned short )0;
  sqlstm.sqhstv[2] = (         void  *)&clm3;
  sqlstm.sqhstl[2] = (unsigned int  )12;
  sqlstm.sqhsts[2] = (         int  )0;
  sqlstm.sqindv[2] = (         void  *)&indic3;
  sqlstm.sqinds[2] = (         int  )0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqadto[2] = (unsigned short )0;
  sqlstm.sqtdso[2] = (unsigned short )0;
  sqlstm.sqhstv[3] = (         void  *)&clm4;
  sqlstm.sqhstl[3] = (unsigned int  )41;
  sqlstm.sqhsts[3] = (         int  )0;
  sqlstm.sqindv[3] = (         void  *)&indic4;
  sqlstm.sqinds[3] = (         int  )0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqadto[3] = (unsigned short )0;
  sqlstm.sqtdso[3] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) goto error;
}



                indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
                (*data1)[aant]=strdup((char*)clm1.arr);
                
                indic2==-1 ? (clm2.arr[0] = 0) : (clm2.arr[clm2.len] = 0);
                (*data2)[aant]=strdup((char*)clm2.arr);
                
                indic3==-1 ? (clm3.arr[0] = 0) : (clm3.arr[clm3.len] = 0);
                (*data3)[aant]=strdup((char*)clm3.arr);
                
                indic4==-1 ? (clm4.arr[0] = 0) : (clm4.arr[clm4.len] = 0);
                (*data4)[aant]=strdup((char*)clm4.arr);
		aant++;
	}
	/* EXEC SQL CLOSE bobyargs; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1159;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;	
}


int GetProcedureArguments(char ***data1,char ***data2,char ***data3,char ***data4,const char *procedure,int *aantal,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	clm1[31],clm2[15],clm3[10],clm4[39],procedurename[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } clm1;

struct { unsigned short len; unsigned char arr[15]; } clm2;

struct { unsigned short len; unsigned char arr[10]; } clm3;

struct { unsigned short len; unsigned char arr[39]; } clm4;

struct { unsigned short len; unsigned char arr[31]; } procedurename;

	short indic1,indic2,indic3,indic4;
	int aant;	
	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)procedurename.arr,procedure);
	procedurename.len = strlen((char*)procedurename.arr);
	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	
	/* EXEC SQL SELECT count(1) 
		 INTO :aant
		 FROM  user_arguments
		 WHERE object_name = :procedurename; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select count(1) into :b0  from user_arguments where object_n\
ame=:b1";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1174;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&aant;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&procedurename;
 sqlstm.sqhstl[1] = (unsigned int  )33;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	

	*aantal=aant;
	*data1 = (char**)realloc(*data1,aant*sizeof(char*));
	*data2 = (char**)realloc(*data2,aant*sizeof(char*));
	*data3 = (char**)realloc(*data3,aant*sizeof(char*));
	*data4 = (char**)realloc(*data4,aant*sizeof(char*));
	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL DECLARE procargs CURSOR FOR 
	SELECT argument_name,data_type,in_out,to_char(position)
	FROM user_arguments
	WHERE object_name = :procedurename
	   and data_level = 0
	ORDER BY position; */ 

	   
	/* EXEC SQL OPEN procargs; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = sq0031;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1197;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&procedurename;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



	/* EXEC SQL WHENEVER NOT FOUND DO break; */ 

	aant = 0;
	for (;;) 
	{
		/* EXEC SQL FETCH procargs
		INTO :clm1:indic1, :clm2:indic2, :clm3:indic3, :clm4:indic4; */ 

{
  struct sqlexd sqlstm;
  sqlstm.sqlvsn = 10;
  sqlstm.arrsiz = 4;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )1216;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlstm.sqhstv[0] = (         void  *)&clm1;
  sqlstm.sqhstl[0] = (unsigned int  )33;
  sqlstm.sqhsts[0] = (         int  )0;
  sqlstm.sqindv[0] = (         void  *)&indic1;
  sqlstm.sqinds[0] = (         int  )0;
  sqlstm.sqharm[0] = (unsigned int  )0;
  sqlstm.sqadto[0] = (unsigned short )0;
  sqlstm.sqtdso[0] = (unsigned short )0;
  sqlstm.sqhstv[1] = (         void  *)&clm2;
  sqlstm.sqhstl[1] = (unsigned int  )17;
  sqlstm.sqhsts[1] = (         int  )0;
  sqlstm.sqindv[1] = (         void  *)&indic2;
  sqlstm.sqinds[1] = (         int  )0;
  sqlstm.sqharm[1] = (unsigned int  )0;
  sqlstm.sqadto[1] = (unsigned short )0;
  sqlstm.sqtdso[1] = (unsigned short )0;
  sqlstm.sqhstv[2] = (         void  *)&clm3;
  sqlstm.sqhstl[2] = (unsigned int  )12;
  sqlstm.sqhsts[2] = (         int  )0;
  sqlstm.sqindv[2] = (         void  *)&indic3;
  sqlstm.sqinds[2] = (         int  )0;
  sqlstm.sqharm[2] = (unsigned int  )0;
  sqlstm.sqadto[2] = (unsigned short )0;
  sqlstm.sqtdso[2] = (unsigned short )0;
  sqlstm.sqhstv[3] = (         void  *)&clm4;
  sqlstm.sqhstl[3] = (unsigned int  )41;
  sqlstm.sqhsts[3] = (         int  )0;
  sqlstm.sqindv[3] = (         void  *)&indic4;
  sqlstm.sqinds[3] = (         int  )0;
  sqlstm.sqharm[3] = (unsigned int  )0;
  sqlstm.sqadto[3] = (unsigned short )0;
  sqlstm.sqtdso[3] = (unsigned short )0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqphss = sqlstm.sqhsts;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqpins = sqlstm.sqinds;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlstm.sqpadto = sqlstm.sqadto;
  sqlstm.sqptdso = sqlstm.sqtdso;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) break;
  if (sqlca.sqlcode < 0) goto error;
}



                indic1==-1 ? (clm1.arr[0] = 0) : (clm1.arr[clm1.len] = 0);
                (*data1)[aant]=strdup((char*)clm1.arr);
                
                indic2==-1 ? (clm2.arr[0] = 0) : (clm2.arr[clm2.len] = 0);
                (*data2)[aant]=strdup((char*)clm2.arr);
                
                indic3==-1 ? (clm3.arr[0] = 0) : (clm3.arr[clm3.len] = 0);
                (*data3)[aant]=strdup((char*)clm3.arr);
                
                indic4==-1 ? (clm4.arr[0] = 0) : (clm4.arr[clm4.len] = 0);
                (*data4)[aant]=strdup((char*)clm4.arr);

		aant++;
	}
	/* EXEC SQL CLOSE procargs; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1247;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;	
}

int GetSchemaName(char *schema,char **err)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar v_schema[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } v_schema;

	/* EXEC SQL END DECLARE SECTION; */ 

	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND GOTO error; */ 

	
	/* EXEC SQL SELECT username
		 INTO :v_schema
		 FROM  user_users; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select username into :b0  from user_users ";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1262;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&v_schema;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode == 1403) goto error;
 if (sqlca.sqlcode < 0) goto error;
}


	

	v_schema.arr[v_schema.len]=0;
	strcpy(schema,(char*)v_schema.arr);
	
	return 1;
error:
	SqlError(err);
	return 0;	
}


int GetTableProperties(const char *tn,const char *own,char* tablespace,long *pct_free ,long *pct_used ,long *pct_incr ,
				long *next_extent ,long *min_extents ,long *max_extents ,long *max_trans ,
				long *ini_trans ,long *initial_extent ,
				long *free_lists ,long *free_list_groups ,char **err)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	v_tn[31],v_own[31],v_tablespace[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } v_tn;

struct { unsigned short len; unsigned char arr[31]; } v_own;

struct { unsigned short len; unsigned char arr[31]; } v_tablespace;

	short indic1,indic2,indic3,indic4,indic5,indic6;
	short indic7,indic8,indic9,indic10,indic11,indic12;
	long v_pct_free ;
	long v_pct_used ;
	long v_pct_incr ;
	long v_next_extent ;
	long v_min_extents ;
	long v_max_extents ;
	long v_max_trans ;
	long v_ini_trans ;
	long v_initial_extent ;
	long v_free_lists ;
	long v_free_list_groups ;
	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char *)v_tn.arr,tn);
	v_tn.len = strlen((char *)v_tn.arr);
	strcpy((char *)v_own.arr,own);
	v_own.len = strlen((char *)v_own.arr);
	v_tablespace.len = 0;

	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND GOTO error; */ 

	
	/* EXEC SQL SELECT TABLESPACE_NAME,PCT_FREE,PCT_USED,INI_TRANS,
			MAX_TRANS,INITIAL_EXTENT,NEXT_EXTENT,MIN_EXTENTS,
			MAX_EXTENTS,PCT_INCREASE,FREELISTS,FREELIST_GROUPS
		 INTO   :v_tablespace:indic1,
				:v_pct_free:indic2,
				:v_pct_used:indic3,
				:v_ini_trans:indic4,
		 		:v_max_trans:indic5,
		 		:v_initial_extent:indic6,
		 		:v_next_extent:indic7,
		 		:v_min_extents:indic8,
		 		:v_max_extents:indic9,
		 		:v_pct_incr:indic10,
		 		:v_free_lists:indic11,
		 		:v_free_list_groups:indic12
		 FROM all_tables
		 WHERE table_name = upper(:v_tn)
		   and owner = upper(:v_own); */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 14;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select TABLESPACE_NAME ,PCT_FREE ,PCT_USED ,INI_TRANS ,MAX_T\
RANS ,INITIAL_EXTENT ,NEXT_EXTENT ,MIN_EXTENTS ,MAX_EXTENTS ,PCT_INCREASE ,FRE\
ELISTS ,FREELIST_GROUPS into :b0:b1,:b2:b3,:b4:b5,:b6:b7,:b8:b9,:b10:b11,:b12:\
b13,:b14:b15,:b16:b17,:b18:b19,:b20:b21,:b22:b23  from all_tables where (table\
_name=upper(:b24) and owner=upper(:b25))";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1281;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&v_tablespace;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)&indic1;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&v_pct_free;
 sqlstm.sqhstl[1] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)&indic2;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&v_pct_used;
 sqlstm.sqhstl[2] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         void  *)&indic3;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqhstv[3] = (         void  *)&v_ini_trans;
 sqlstm.sqhstl[3] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[3] = (         int  )0;
 sqlstm.sqindv[3] = (         void  *)&indic4;
 sqlstm.sqinds[3] = (         int  )0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqadto[3] = (unsigned short )0;
 sqlstm.sqtdso[3] = (unsigned short )0;
 sqlstm.sqhstv[4] = (         void  *)&v_max_trans;
 sqlstm.sqhstl[4] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[4] = (         int  )0;
 sqlstm.sqindv[4] = (         void  *)&indic5;
 sqlstm.sqinds[4] = (         int  )0;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqadto[4] = (unsigned short )0;
 sqlstm.sqtdso[4] = (unsigned short )0;
 sqlstm.sqhstv[5] = (         void  *)&v_initial_extent;
 sqlstm.sqhstl[5] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[5] = (         int  )0;
 sqlstm.sqindv[5] = (         void  *)&indic6;
 sqlstm.sqinds[5] = (         int  )0;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqadto[5] = (unsigned short )0;
 sqlstm.sqtdso[5] = (unsigned short )0;
 sqlstm.sqhstv[6] = (         void  *)&v_next_extent;
 sqlstm.sqhstl[6] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[6] = (         int  )0;
 sqlstm.sqindv[6] = (         void  *)&indic7;
 sqlstm.sqinds[6] = (         int  )0;
 sqlstm.sqharm[6] = (unsigned int  )0;
 sqlstm.sqadto[6] = (unsigned short )0;
 sqlstm.sqtdso[6] = (unsigned short )0;
 sqlstm.sqhstv[7] = (         void  *)&v_min_extents;
 sqlstm.sqhstl[7] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[7] = (         int  )0;
 sqlstm.sqindv[7] = (         void  *)&indic8;
 sqlstm.sqinds[7] = (         int  )0;
 sqlstm.sqharm[7] = (unsigned int  )0;
 sqlstm.sqadto[7] = (unsigned short )0;
 sqlstm.sqtdso[7] = (unsigned short )0;
 sqlstm.sqhstv[8] = (         void  *)&v_max_extents;
 sqlstm.sqhstl[8] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[8] = (         int  )0;
 sqlstm.sqindv[8] = (         void  *)&indic9;
 sqlstm.sqinds[8] = (         int  )0;
 sqlstm.sqharm[8] = (unsigned int  )0;
 sqlstm.sqadto[8] = (unsigned short )0;
 sqlstm.sqtdso[8] = (unsigned short )0;
 sqlstm.sqhstv[9] = (         void  *)&v_pct_incr;
 sqlstm.sqhstl[9] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[9] = (         int  )0;
 sqlstm.sqindv[9] = (         void  *)&indic10;
 sqlstm.sqinds[9] = (         int  )0;
 sqlstm.sqharm[9] = (unsigned int  )0;
 sqlstm.sqadto[9] = (unsigned short )0;
 sqlstm.sqtdso[9] = (unsigned short )0;
 sqlstm.sqhstv[10] = (         void  *)&v_free_lists;
 sqlstm.sqhstl[10] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[10] = (         int  )0;
 sqlstm.sqindv[10] = (         void  *)&indic11;
 sqlstm.sqinds[10] = (         int  )0;
 sqlstm.sqharm[10] = (unsigned int  )0;
 sqlstm.sqadto[10] = (unsigned short )0;
 sqlstm.sqtdso[10] = (unsigned short )0;
 sqlstm.sqhstv[11] = (         void  *)&v_free_list_groups;
 sqlstm.sqhstl[11] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[11] = (         int  )0;
 sqlstm.sqindv[11] = (         void  *)&indic12;
 sqlstm.sqinds[11] = (         int  )0;
 sqlstm.sqharm[11] = (unsigned int  )0;
 sqlstm.sqadto[11] = (unsigned short )0;
 sqlstm.sqtdso[11] = (unsigned short )0;
 sqlstm.sqhstv[12] = (         void  *)&v_tn;
 sqlstm.sqhstl[12] = (unsigned int  )33;
 sqlstm.sqhsts[12] = (         int  )0;
 sqlstm.sqindv[12] = (         void  *)0;
 sqlstm.sqinds[12] = (         int  )0;
 sqlstm.sqharm[12] = (unsigned int  )0;
 sqlstm.sqadto[12] = (unsigned short )0;
 sqlstm.sqtdso[12] = (unsigned short )0;
 sqlstm.sqhstv[13] = (         void  *)&v_own;
 sqlstm.sqhstl[13] = (unsigned int  )33;
 sqlstm.sqhsts[13] = (         int  )0;
 sqlstm.sqindv[13] = (         void  *)0;
 sqlstm.sqinds[13] = (         int  )0;
 sqlstm.sqharm[13] = (unsigned int  )0;
 sqlstm.sqadto[13] = (unsigned short )0;
 sqlstm.sqtdso[13] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode == 1403) goto error;
 if (sqlca.sqlcode < 0) goto error;
}



	indic1==-1  ? (v_tablespace.arr[0] = 0) : (v_tablespace.arr[v_tablespace.len] = 0);
	
	strcpy(tablespace,(char *)v_tablespace.arr);
	
	(indic2==-1)  ? (*pct_free = 0)         : (*pct_free = v_pct_free);
	(indic3==-1)  ? (*pct_used = 0)         : (*pct_used = v_pct_used);
	(indic4==-1)  ? (*ini_trans = 0)        : (*ini_trans = v_ini_trans);
	(indic5==-1)  ? (*max_trans = 0)        : (*max_trans = v_max_trans);
	(indic6==-1)  ? (*initial_extent = 0)   : (*initial_extent = v_initial_extent);
	(indic7==-1)  ? (*next_extent = 0)      : (*next_extent = v_next_extent);
	(indic8==-1)  ? (*min_extents = 0)      : (*min_extents = v_min_extents);
	(indic9==-1)  ? (*max_extents = 0)      : (*max_extents = v_max_extents);
	(indic10==-1)  ? (*pct_incr = 0)         : (*pct_incr = v_pct_incr);
	(indic11==-1) ? (*free_lists = 0)       : (*free_lists = v_free_lists);
	(indic12==-1) ? (*free_list_groups = 0) : (*free_list_groups = v_free_list_groups);

	return 1;
error:
	SqlError(err);
	return 0;
	
}

int GetTableStats(const char *tn,const char *own,
			long *rowcount ,
			long *chained_rows ,
			long *avg_row_len ,
			long *blocks_on_freelist ,
			long *avg_free_space ,
			long *blocks_not_used ,
			long *blocks_used ,
			char *last_analyze ,
			long *sample_size ,char **err)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar	v_tn[31],v_own[31],v_last_analyze[20]; */ 
struct { unsigned short len; unsigned char arr[31]; } v_tn;

struct { unsigned short len; unsigned char arr[31]; } v_own;

struct { unsigned short len; unsigned char arr[20]; } v_last_analyze;

	long v_rowcount ;
	long v_chained_rows ;
	long v_avg_row_len ;
	long v_blocks_on_freelist ;
	long v_avg_free_space ;
	long v_blocks_not_used ;
	long v_blocks_used ;
	long v_sample_size ;
	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char *)v_tn.arr,tn);
	v_tn.len = strlen((char *)v_tn.arr);
	
	strcpy((char *)v_own.arr,own);
	v_own.len = strlen((char *)v_own.arr);
	
	v_last_analyze.len = 0;

	
	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL WHENEVER NOT FOUND GOTO error; */ 

	
	/* EXEC SQL SELECT nvl(num_rows,0),
			nvl(chain_cnt,0),
			nvl(avg_row_len,0),
			nvl(num_freelist_blocks,0),
			nvl(avg_space,0),
			nvl(empty_blocks,0),
			nvl(blocks,0),
			nvl(to_char(last_analyzed,'dd/mm/yyyy hh24:mi'),'N/A'),
			nvl(sample_size,0)
		 INTO :v_rowcount ,
		      :v_chained_rows ,
		      :v_avg_row_len ,
		      :v_blocks_on_freelist ,
		      :v_avg_free_space ,
		      :v_blocks_not_used ,
		      :v_blocks_used ,
		      :v_last_analyze ,
		      :v_sample_size
		 FROM all_tables
		 WHERE table_name = upper(:v_tn)
		   and owner = upper(:v_own); */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 14;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "select nvl(num_rows,0) ,nvl(chain_cnt,0) ,nvl(avg_row_len,0)\
 ,nvl(num_freelist_blocks,0) ,nvl(avg_space,0) ,nvl(empty_blocks,0) ,nvl(block\
s,0) ,nvl(to_char(last_analyzed,'dd/mm/yyyy hh24:mi'),'N/A') ,nvl(sample_size,\
0) into :b0,:b1,:b2,:b3,:b4,:b5,:b6,:b7,:b8  from all_tables where (table_name\
=upper(:b9) and owner=upper(:b10))";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1352;
 sqlstm.selerr = (unsigned short)1;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&v_rowcount;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&v_chained_rows;
 sqlstm.sqhstl[1] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&v_avg_row_len;
 sqlstm.sqhstl[2] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqhstv[3] = (         void  *)&v_blocks_on_freelist;
 sqlstm.sqhstl[3] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[3] = (         int  )0;
 sqlstm.sqindv[3] = (         void  *)0;
 sqlstm.sqinds[3] = (         int  )0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqadto[3] = (unsigned short )0;
 sqlstm.sqtdso[3] = (unsigned short )0;
 sqlstm.sqhstv[4] = (         void  *)&v_avg_free_space;
 sqlstm.sqhstl[4] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[4] = (         int  )0;
 sqlstm.sqindv[4] = (         void  *)0;
 sqlstm.sqinds[4] = (         int  )0;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqadto[4] = (unsigned short )0;
 sqlstm.sqtdso[4] = (unsigned short )0;
 sqlstm.sqhstv[5] = (         void  *)&v_blocks_not_used;
 sqlstm.sqhstl[5] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[5] = (         int  )0;
 sqlstm.sqindv[5] = (         void  *)0;
 sqlstm.sqinds[5] = (         int  )0;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqadto[5] = (unsigned short )0;
 sqlstm.sqtdso[5] = (unsigned short )0;
 sqlstm.sqhstv[6] = (         void  *)&v_blocks_used;
 sqlstm.sqhstl[6] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[6] = (         int  )0;
 sqlstm.sqindv[6] = (         void  *)0;
 sqlstm.sqinds[6] = (         int  )0;
 sqlstm.sqharm[6] = (unsigned int  )0;
 sqlstm.sqadto[6] = (unsigned short )0;
 sqlstm.sqtdso[6] = (unsigned short )0;
 sqlstm.sqhstv[7] = (         void  *)&v_last_analyze;
 sqlstm.sqhstl[7] = (unsigned int  )22;
 sqlstm.sqhsts[7] = (         int  )0;
 sqlstm.sqindv[7] = (         void  *)0;
 sqlstm.sqinds[7] = (         int  )0;
 sqlstm.sqharm[7] = (unsigned int  )0;
 sqlstm.sqadto[7] = (unsigned short )0;
 sqlstm.sqtdso[7] = (unsigned short )0;
 sqlstm.sqhstv[8] = (         void  *)&v_sample_size;
 sqlstm.sqhstl[8] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[8] = (         int  )0;
 sqlstm.sqindv[8] = (         void  *)0;
 sqlstm.sqinds[8] = (         int  )0;
 sqlstm.sqharm[8] = (unsigned int  )0;
 sqlstm.sqadto[8] = (unsigned short )0;
 sqlstm.sqtdso[8] = (unsigned short )0;
 sqlstm.sqhstv[9] = (         void  *)&v_tn;
 sqlstm.sqhstl[9] = (unsigned int  )33;
 sqlstm.sqhsts[9] = (         int  )0;
 sqlstm.sqindv[9] = (         void  *)0;
 sqlstm.sqinds[9] = (         int  )0;
 sqlstm.sqharm[9] = (unsigned int  )0;
 sqlstm.sqadto[9] = (unsigned short )0;
 sqlstm.sqtdso[9] = (unsigned short )0;
 sqlstm.sqhstv[10] = (         void  *)&v_own;
 sqlstm.sqhstl[10] = (unsigned int  )33;
 sqlstm.sqhsts[10] = (         int  )0;
 sqlstm.sqindv[10] = (         void  *)0;
 sqlstm.sqinds[10] = (         int  )0;
 sqlstm.sqharm[10] = (unsigned int  )0;
 sqlstm.sqadto[10] = (unsigned short )0;
 sqlstm.sqtdso[10] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode == 1403) goto error;
 if (sqlca.sqlcode < 0) goto error;
}



	v_last_analyze.arr[v_last_analyze.len] = 0;
	strcpy(last_analyze,(char *)v_last_analyze.arr);
	
	*rowcount= v_rowcount ;
	*chained_rows= v_chained_rows ;
	*avg_row_len= v_avg_row_len ;
	*blocks_on_freelist= v_blocks_on_freelist ;
	*avg_free_space= v_avg_free_space ;
	*blocks_not_used= v_blocks_not_used ;
	*blocks_used= v_blocks_used ;
	*sample_size= v_sample_size ;

	return 1;
error:
	SqlError(err);
	return 0;
	
}

int ReadFromPipe(const char *pipe,char* type,char *message,char** resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar pipe_name[31],msg_type[10], msg_txt[4000]; */ 
struct { unsigned short len; unsigned char arr[31]; } pipe_name;

struct { unsigned short len; unsigned char arr[10]; } msg_type;

struct { unsigned short len; unsigned char arr[4000]; } msg_txt;

	int return_value;
	/* EXEC SQL END DECLARE SECTION; */ 

	
	return_value  = 0;
	msg_type.len  = 0;
	msg_txt.len   = 0;
	
	strcpy((char*)pipe_name.arr,pipe);
	pipe_name.len = strlen((char*)pipe_name.arr);
	
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL EXECUTE
	
	BEGIN 
	        :return_value:=dbms_pipe.receive_message(:pipe_name,0);
	        if :return_value = 0 then
	        	dbms_pipe.unpack_message(:msg_type);
        		dbms_pipe.unpack_message(:msg_txt);
        	end if;
	END; 
	END-EXEC; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 14;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "begin :return_value := dbms_pipe . receive_message ( :pipe_n\
ame , 0 ) ; if :return_value = 0 then dbms_pipe . unpack_message ( :msg_type )\
 ; dbms_pipe . unpack_message ( :msg_txt ) ; end if ; END ;";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1411;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&return_value;
 sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&pipe_name;
 sqlstm.sqhstl[1] = (unsigned int  )33;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&msg_type;
 sqlstm.sqhstl[2] = (unsigned int  )12;
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqhstv[3] = (         void  *)&msg_txt;
 sqlstm.sqhstl[3] = (unsigned int  )4002;
 sqlstm.sqhsts[3] = (         int  )0;
 sqlstm.sqindv[3] = (         void  *)0;
 sqlstm.sqinds[3] = (         int  )0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqadto[3] = (unsigned short )0;
 sqlstm.sqtdso[3] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	
	msg_type.arr[msg_type.len]=0;
	msg_txt.arr[msg_txt.len]=0;
	
	strcpy(type,(char*)msg_type.arr);
	strcpy(message,(char*)msg_txt.arr);
    	return return_value;

error:
	SqlError(resp);
	return -1;    	
}

int SendToPipe(const char *pipe,const char* type,char *message,char** resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar pipe_name[31],msg_type[10], msg_txt[4000]; */ 
struct { unsigned short len; unsigned char arr[31]; } pipe_name;

struct { unsigned short len; unsigned char arr[10]; } msg_type;

struct { unsigned short len; unsigned char arr[4000]; } msg_txt;

	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)pipe_name.arr,pipe);
	pipe_name.len = strlen((char*)pipe_name.arr);
	strcpy((char*)msg_type.arr,type);
	msg_type.len = strlen((char*)msg_type.arr);
	strcpy((char*)msg_txt.arr,message);
	msg_txt.len = strlen((char*)msg_txt.arr);

	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL EXECUTE
	DECLARE
		x NUMBER;
	BEGIN 
	       	dbms_pipe.pack_message(:msg_type);
        	dbms_pipe.pack_message(:msg_txt);

        	x:=dbms_pipe.send_message(:pipe_name,1);
	END; 
	END-EXEC; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 14;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "declare x NUMBER ; BEGIN dbms_pipe . pack_message ( :msg_typ\
e ) ; dbms_pipe . pack_message ( :msg_txt ) ; x := dbms_pipe . send_message ( \
:pipe_name , 1 ) ; END ;";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1442;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&msg_type;
 sqlstm.sqhstl[0] = (unsigned int  )12;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&msg_txt;
 sqlstm.sqhstl[1] = (unsigned int  )4002;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&pipe_name;
 sqlstm.sqhstl[2] = (unsigned int  )33;
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}



    	return 1;

error:
	SqlError(resp);
	return 0;    	
}

int DropColumn(char* column,char *table,char *owner,char* pipe,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar table_name[31],table_owner[31],column_name[129],pipe_name[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } table_name;

struct { unsigned short len; unsigned char arr[31]; } table_owner;

struct { unsigned short len; unsigned char arr[129]; } column_name;

struct { unsigned short len; unsigned char arr[31]; } pipe_name;

	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)table_owner.arr,owner);
	table_owner.len = strlen((char*)table_owner.arr);

	strcpy((char*)table_name.arr,table);
	table_name.len = strlen((char*)table_name.arr);
	
	strcpy((char*)pipe_name.arr,pipe);
	pipe_name.len = strlen((char*)pipe_name.arr);
	
	strcpy((char*)column_name.arr,column);
	column_name.len = strlen((char*)column_name.arr);
	
	/*printf("Drop colum table = '%s', column = '%s', owner = '%s'",
			table_name.arr,column_name.arr,table_owner.arr);*/
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL EXECUTE
	BEGIN 
		tabman.setpipename(:pipe_name,TRUE,TRUE);
		tabman.dropcolumn(upper(:table_name),upper(:column_name),upper(:table_owner));
	END; 
	END-EXEC; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 14;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "begin tabman . setpipename ( :pipe_name , TRUE , TRUE ) ; ta\
bman . dropcolumn ( upper ( :table_name ) , upper ( :column_name ) , upper ( :\
table_owner ) ) ; END ;";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1469;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&pipe_name;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&table_name;
 sqlstm.sqhstl[1] = (unsigned int  )33;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&column_name;
 sqlstm.sqhstl[2] = (unsigned int  )131;
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqhstv[3] = (         void  *)&table_owner;
 sqlstm.sqhstl[3] = (unsigned int  )33;
 sqlstm.sqhsts[3] = (         int  )0;
 sqlstm.sqindv[3] = (         void  *)0;
 sqlstm.sqinds[3] = (         int  )0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqadto[3] = (unsigned short )0;
 sqlstm.sqtdso[3] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;
}

int DropTable(char* tn,char *own,char* pipe,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar table_name[31],table_owner[129],pipe_name[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } table_name;

struct { unsigned short len; unsigned char arr[129]; } table_owner;

struct { unsigned short len; unsigned char arr[31]; } pipe_name;

	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)table_name.arr,tn);
	table_name.len = strlen((char*)table_name.arr);

	strcpy((char*)table_owner.arr,own);
	table_owner.len = strlen((char*)table_owner.arr);
	
	strcpy((char*)pipe_name.arr,pipe);
	pipe_name.len = strlen((char*)pipe_name.arr);
	
	/*printf("Drop  table = '%s',  owner = '%s' (pipe = '%s')",
			table_name.arr,table_owner.arr,pipe_name.arr);*/
		
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL EXECUTE
	BEGIN 
		tabman.setpipename(:pipe_name,TRUE,TRUE);
		tabman.droptable(upper(:table_name),upper(:table_owner));
	END; 
	END-EXEC; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 14;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "begin tabman . setpipename ( :pipe_name , TRUE , TRUE ) ; ta\
bman . droptable ( upper ( :table_name ) , upper ( :table_owner ) ) ; END ;";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1500;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&pipe_name;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&table_name;
 sqlstm.sqhstl[1] = (unsigned int  )33;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&table_owner;
 sqlstm.sqhstl[2] = (unsigned int  )131;
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;
}

int DropIndex(char* in,char *own,char* pipe,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar index_name[31],index_owner[129],pipe_name[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } index_name;

struct { unsigned short len; unsigned char arr[129]; } index_owner;

struct { unsigned short len; unsigned char arr[31]; } pipe_name;

	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)index_name.arr,in);
	index_name.len = strlen((char*)index_name.arr);

	strcpy((char*)index_owner.arr,own);
	index_owner.len = strlen((char*)index_owner.arr);
	
	strcpy((char*)pipe_name.arr,pipe);
	pipe_name.len = strlen((char*)pipe_name.arr);
	
	/*printf("Drop  table = '%s',  owner = '%s' (pipe = '%s')",
			index_name.arr,index_owner.arr,pipe_name.arr);*/
		
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL EXECUTE
	BEGIN 
		tabman.setpipename(:pipe_name,TRUE,TRUE);
		tabman.dropindex(upper(:index_name),upper(:index_owner));
	END; 
	END-EXEC; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 14;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "begin tabman . setpipename ( :pipe_name , TRUE , TRUE ) ; ta\
bman . dropindex ( upper ( :index_name ) , upper ( :index_owner ) ) ; END ;";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1527;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&pipe_name;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&index_name;
 sqlstm.sqhstl[1] = (unsigned int  )33;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&index_owner;
 sqlstm.sqhstl[2] = (unsigned int  )131;
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;
}


int DropTrigger(char* tr,char *own,char* pipe,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar trigger_name[31],trigger_owner[129],pipe_name[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } trigger_name;

struct { unsigned short len; unsigned char arr[129]; } trigger_owner;

struct { unsigned short len; unsigned char arr[31]; } pipe_name;

	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)trigger_name.arr,tr);
	trigger_name.len = strlen((char*)trigger_name.arr);

	strcpy((char*)trigger_owner.arr,own);
	trigger_owner.len = strlen((char*)trigger_owner.arr);
	
	strcpy((char*)pipe_name.arr,pipe);
	pipe_name.len = strlen((char*)pipe_name.arr);
	
	/*printf("Drop  table = '%s',  owner = '%s' (pipe = '%s')",
			trigger_name.arr,trigger_owner.arr,pipe_name.arr);*/
		
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL EXECUTE
	BEGIN 
		tabman.setpipename(:pipe_name,TRUE,TRUE);
		tabman.droptrigger(upper(:trigger_name),upper(:trigger_owner));
	END; 
	END-EXEC; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 14;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "begin tabman . setpipename ( :pipe_name , TRUE , TRUE ) ; ta\
bman . droptrigger ( upper ( :trigger_name ) , upper ( :trigger_owner ) ) ; EN\
D ;";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1554;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&pipe_name;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&trigger_name;
 sqlstm.sqhstl[1] = (unsigned int  )33;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&trigger_owner;
 sqlstm.sqhstl[2] = (unsigned int  )131;
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;
}


int DropConstraint(char* con,char *own,char* pipe,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar constraint_name[31],constraint_owner[129],pipe_name[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } constraint_name;

struct { unsigned short len; unsigned char arr[129]; } constraint_owner;

struct { unsigned short len; unsigned char arr[31]; } pipe_name;

	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)constraint_name.arr,con);
	constraint_name.len = strlen((char*)constraint_name.arr);

	strcpy((char*)constraint_owner.arr,own);
	constraint_owner.len = strlen((char*)constraint_owner.arr);
	
	strcpy((char*)pipe_name.arr,pipe);
	pipe_name.len = strlen((char*)pipe_name.arr);
	
	/*printf("Drop  table = '%s',  owner = '%s' (pipe = '%s')",
			constraint_name.arr,constraint_owner.arr,pipe_name.arr);*/
		
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL EXECUTE
	BEGIN 
		tabman.setpipename(:pipe_name,TRUE,TRUE);
		tabman.dropconstraint(upper(:constraint_name),upper(:constraint_owner));
	END; 
	END-EXEC; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 14;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "begin tabman . setpipename ( :pipe_name , TRUE , TRUE ) ; ta\
bman . dropconstraint ( upper ( :constraint_name ) , upper ( :constraint_owner\
 ) ) ; END ;";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1581;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&pipe_name;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&constraint_name;
 sqlstm.sqhstl[1] = (unsigned int  )33;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&constraint_owner;
 sqlstm.sqhstl[2] = (unsigned int  )131;
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;
}

int AlterTable(char *pipe,char *tn,char *own,char *new_tn,char* new_own,char* tablespace,
				long pct_free ,long pct_used ,long pct_incr ,
				long next_extent ,long min_extents ,long max_extents ,long max_trans,
				long ini_trans ,long initial_extent ,
				long free_lists ,long free_list_groups ,char **err)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar v_tn[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } v_tn;

	/* varchar pipe_name[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } pipe_name;

	/* varchar v_new_tn[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } v_new_tn;

	/* varchar v_own[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } v_own;

	/* varchar v_new_own[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } v_new_own;

	/* varchar v_tablespace[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } v_tablespace;

	
	long v_pct_free = pct_free;
	long v_pct_used = pct_used;
	long v_pct_incr = pct_incr;
	long v_next_extent = next_extent;
	long v_min_extents = min_extents;
	long v_max_extents = max_extents;
	long v_max_trans = max_trans;
	long v_ini_trans = ini_trans;
	long v_initial_extent = initial_extent;
	long v_free_lists = free_lists;
	long v_free_list_groups = free_list_groups;
	/* EXEC SQL END DECLARE SECTION; */ 


	strcpy((char*)pipe_name.arr,pipe);
	pipe_name.len = strlen((char*)pipe_name.arr);

	strcpy((char*)v_tn.arr,tn);
	v_tn.len = strlen((char*)v_tn.arr);

	strcpy((char*)v_new_tn.arr,new_tn);
	v_new_tn.len = strlen((char*)v_new_tn.arr);

	strcpy((char*)v_own.arr,own);
	v_own.len = strlen((char*)v_own.arr);

	strcpy((char*)v_new_own.arr,new_own);
	v_new_own.len = strlen((char*)v_new_own.arr);

	strcpy((char*)v_tablespace.arr,tablespace);
	v_tablespace.len = strlen((char*)v_tablespace.arr);


	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL EXECUTE
	BEGIN 
		tabman.setpipename(:pipe_name,TRUE,TRUE);
		tabman.altertable(upper(:v_tn),upper(:v_new_tn),:v_tablespace,:v_pct_free,
				:v_pct_used,:v_ini_trans,:v_max_trans,:v_initial_extent,
				:v_next_extent,:v_min_extents,:v_max_extents,:v_pct_incr,:v_free_lists,
				:v_free_list_groups,:v_own,:v_new_own);
	END; 
	END-EXEC; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 17;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "begin tabman . setpipename ( :pipe_name , TRUE , TRUE ) ; ta\
bman . altertable ( upper ( :v_tn ) , upper ( :v_new_tn ) , :v_tablespace , :v\
_pct_free , :v_pct_used , :v_ini_trans , :v_max_trans , :v_initial_extent , :v\
_next_extent , :v_min_extents , :v_max_extents , :v_pct_incr , :v_free_lists ,\
 :v_free_list_groups , :v_own , :v_new_own ) ; END ;";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1608;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&pipe_name;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&v_tn;
 sqlstm.sqhstl[1] = (unsigned int  )33;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (         void  *)&v_new_tn;
 sqlstm.sqhstl[2] = (unsigned int  )33;
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         void  *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned int  )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqhstv[3] = (         void  *)&v_tablespace;
 sqlstm.sqhstl[3] = (unsigned int  )33;
 sqlstm.sqhsts[3] = (         int  )0;
 sqlstm.sqindv[3] = (         void  *)0;
 sqlstm.sqinds[3] = (         int  )0;
 sqlstm.sqharm[3] = (unsigned int  )0;
 sqlstm.sqadto[3] = (unsigned short )0;
 sqlstm.sqtdso[3] = (unsigned short )0;
 sqlstm.sqhstv[4] = (         void  *)&v_pct_free;
 sqlstm.sqhstl[4] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[4] = (         int  )0;
 sqlstm.sqindv[4] = (         void  *)0;
 sqlstm.sqinds[4] = (         int  )0;
 sqlstm.sqharm[4] = (unsigned int  )0;
 sqlstm.sqadto[4] = (unsigned short )0;
 sqlstm.sqtdso[4] = (unsigned short )0;
 sqlstm.sqhstv[5] = (         void  *)&v_pct_used;
 sqlstm.sqhstl[5] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[5] = (         int  )0;
 sqlstm.sqindv[5] = (         void  *)0;
 sqlstm.sqinds[5] = (         int  )0;
 sqlstm.sqharm[5] = (unsigned int  )0;
 sqlstm.sqadto[5] = (unsigned short )0;
 sqlstm.sqtdso[5] = (unsigned short )0;
 sqlstm.sqhstv[6] = (         void  *)&v_ini_trans;
 sqlstm.sqhstl[6] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[6] = (         int  )0;
 sqlstm.sqindv[6] = (         void  *)0;
 sqlstm.sqinds[6] = (         int  )0;
 sqlstm.sqharm[6] = (unsigned int  )0;
 sqlstm.sqadto[6] = (unsigned short )0;
 sqlstm.sqtdso[6] = (unsigned short )0;
 sqlstm.sqhstv[7] = (         void  *)&v_max_trans;
 sqlstm.sqhstl[7] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[7] = (         int  )0;
 sqlstm.sqindv[7] = (         void  *)0;
 sqlstm.sqinds[7] = (         int  )0;
 sqlstm.sqharm[7] = (unsigned int  )0;
 sqlstm.sqadto[7] = (unsigned short )0;
 sqlstm.sqtdso[7] = (unsigned short )0;
 sqlstm.sqhstv[8] = (         void  *)&v_initial_extent;
 sqlstm.sqhstl[8] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[8] = (         int  )0;
 sqlstm.sqindv[8] = (         void  *)0;
 sqlstm.sqinds[8] = (         int  )0;
 sqlstm.sqharm[8] = (unsigned int  )0;
 sqlstm.sqadto[8] = (unsigned short )0;
 sqlstm.sqtdso[8] = (unsigned short )0;
 sqlstm.sqhstv[9] = (         void  *)&v_next_extent;
 sqlstm.sqhstl[9] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[9] = (         int  )0;
 sqlstm.sqindv[9] = (         void  *)0;
 sqlstm.sqinds[9] = (         int  )0;
 sqlstm.sqharm[9] = (unsigned int  )0;
 sqlstm.sqadto[9] = (unsigned short )0;
 sqlstm.sqtdso[9] = (unsigned short )0;
 sqlstm.sqhstv[10] = (         void  *)&v_min_extents;
 sqlstm.sqhstl[10] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[10] = (         int  )0;
 sqlstm.sqindv[10] = (         void  *)0;
 sqlstm.sqinds[10] = (         int  )0;
 sqlstm.sqharm[10] = (unsigned int  )0;
 sqlstm.sqadto[10] = (unsigned short )0;
 sqlstm.sqtdso[10] = (unsigned short )0;
 sqlstm.sqhstv[11] = (         void  *)&v_max_extents;
 sqlstm.sqhstl[11] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[11] = (         int  )0;
 sqlstm.sqindv[11] = (         void  *)0;
 sqlstm.sqinds[11] = (         int  )0;
 sqlstm.sqharm[11] = (unsigned int  )0;
 sqlstm.sqadto[11] = (unsigned short )0;
 sqlstm.sqtdso[11] = (unsigned short )0;
 sqlstm.sqhstv[12] = (         void  *)&v_pct_incr;
 sqlstm.sqhstl[12] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[12] = (         int  )0;
 sqlstm.sqindv[12] = (         void  *)0;
 sqlstm.sqinds[12] = (         int  )0;
 sqlstm.sqharm[12] = (unsigned int  )0;
 sqlstm.sqadto[12] = (unsigned short )0;
 sqlstm.sqtdso[12] = (unsigned short )0;
 sqlstm.sqhstv[13] = (         void  *)&v_free_lists;
 sqlstm.sqhstl[13] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[13] = (         int  )0;
 sqlstm.sqindv[13] = (         void  *)0;
 sqlstm.sqinds[13] = (         int  )0;
 sqlstm.sqharm[13] = (unsigned int  )0;
 sqlstm.sqadto[13] = (unsigned short )0;
 sqlstm.sqtdso[13] = (unsigned short )0;
 sqlstm.sqhstv[14] = (         void  *)&v_free_list_groups;
 sqlstm.sqhstl[14] = (unsigned int  )sizeof(long);
 sqlstm.sqhsts[14] = (         int  )0;
 sqlstm.sqindv[14] = (         void  *)0;
 sqlstm.sqinds[14] = (         int  )0;
 sqlstm.sqharm[14] = (unsigned int  )0;
 sqlstm.sqadto[14] = (unsigned short )0;
 sqlstm.sqtdso[14] = (unsigned short )0;
 sqlstm.sqhstv[15] = (         void  *)&v_own;
 sqlstm.sqhstl[15] = (unsigned int  )33;
 sqlstm.sqhsts[15] = (         int  )0;
 sqlstm.sqindv[15] = (         void  *)0;
 sqlstm.sqinds[15] = (         int  )0;
 sqlstm.sqharm[15] = (unsigned int  )0;
 sqlstm.sqadto[15] = (unsigned short )0;
 sqlstm.sqtdso[15] = (unsigned short )0;
 sqlstm.sqhstv[16] = (         void  *)&v_new_own;
 sqlstm.sqhstl[16] = (unsigned int  )33;
 sqlstm.sqhsts[16] = (         int  )0;
 sqlstm.sqindv[16] = (         void  *)0;
 sqlstm.sqinds[16] = (         int  )0;
 sqlstm.sqharm[16] = (unsigned int  )0;
 sqlstm.sqadto[16] = (unsigned short )0;
 sqlstm.sqtdso[16] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(err);
	return 0;
}

int GetVersion(char *version,char **err)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar v_version[4001]; */ 
struct { unsigned short len; unsigned char arr[4001]; } v_version;

	/* EXEC SQL END DECLARE SECTION; */ 

	
	v_version.len = 0;


	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL EXECUTE
	BEGIN 
		:v_version := tabman.GetVersion;
	END; 
	END-EXEC; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 17;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "begin :v_version := tabman . GetVersion ; END ;";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1691;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&v_version;
 sqlstm.sqhstl[0] = (unsigned int  )4003;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	
	v_version.arr[v_version.len]=0;
	strcpy(version,(char*)v_version.arr);
	
	return 1;

error:
	SqlError(err);
	return 0;
}


int ExecDdl(const char* stmt,const char* pipe,char **resp)
{
	/* EXEC SQL BEGIN DECLARE SECTION; */ 

	/* varchar v_stmt[4001],pipe_name[31]; */ 
struct { unsigned short len; unsigned char arr[4001]; } v_stmt;

struct { unsigned short len; unsigned char arr[31]; } pipe_name;

	/* EXEC SQL END DECLARE SECTION; */ 

	
	strcpy((char*)v_stmt.arr,stmt);
	v_stmt.len = strlen((char*)v_stmt.arr);

	strcpy((char*)pipe_name.arr,pipe);
	pipe_name.len = strlen((char*)pipe_name.arr);
			
	/* EXEC SQL WHENEVER NOT FOUND CONTINUE; */ 

	/* EXEC SQL WHENEVER SQLERROR GOTO error; */ 

	/* EXEC SQL EXECUTE
	BEGIN 
		tabman.setpipename(:pipe_name,TRUE,TRUE);
		tabman.ddl(:v_stmt);
	END; 
	END-EXEC; */ 

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 10;
 sqlstm.arrsiz = 17;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "begin tabman . setpipename ( :pipe_name , TRUE , TRUE ) ; ta\
bman . ddl ( :v_stmt ) ; END ;";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )1710;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (         void  *)&pipe_name;
 sqlstm.sqhstl[0] = (unsigned int  )33;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         void  *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned int  )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (         void  *)&v_stmt;
 sqlstm.sqhstl[1] = (unsigned int  )4003;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         void  *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned int  )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto error;
}


	return 1;
error:
	SqlError(resp);
	return 0;
}
